#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 31 "policy_parse.y"
#include <sys/types.h>
#include <assert.h>
#include <stdarg.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>

#include <sepol/policydb/expand.h>
#include <sepol/policydb/policydb.h>
#include <sepol/policydb/services.h>
#include <sepol/policydb/conditional.h>
#include <sepol/policydb/flask.h>
#include <sepol/policydb/hierarchy.h>
#include "queue.h"
#include "checkpolicy.h"
#include "module_compiler.h"

/* 
 * We need the following so we have a valid error return code in yacc
 * when we have a parse error for a conditional rule.  We can't check 
 * for NULL (ie 0) because that is a potentially valid return.
 */
static avrule_t *conditional_unused_error_code;
#define COND_ERR (avrule_t *)&conditional_unused_error_code

#define TRUE 1
#define FALSE 0

policydb_t *policydbp;
queue_t id_queue = 0;
static unsigned int pass;
char *curfile = 0;
int mlspol = 0;

extern unsigned long policydb_lineno;
extern unsigned long source_lineno;
extern unsigned int policydb_errors;
extern unsigned int policyvers;

extern char yytext[];
extern int yylex(void);
extern int yywarn(char *msg);
extern int yyerror(char *msg);

#define ERRORMSG_LEN 255
static char errormsg[ERRORMSG_LEN + 1] = {0};

static int insert_separator(int push);
static int insert_id(char *id,int push);
static int id_has_dot(char *id);
static int define_class(void);
static int define_initial_sid(void);
static int define_common_perms(void);
static int define_av_perms(int inherits);
static int define_sens(void);
static int define_dominance(void);
static int define_category(void);
static int define_level(void);
static int define_attrib(void);
static int define_typealias(void);
static int define_typeattribute(void);
static int define_type(int alias);
static int define_compute_type(int which);
static int define_te_avtab(int which);
static int define_role_types(void);
static role_datum_t *merge_roles_dom(role_datum_t *r1,role_datum_t *r2);
static role_datum_t *define_role_dom(role_datum_t *r);
static int define_role_trans(void);
static int define_range_trans(void);
static int define_role_allow(void);
static int define_constraint(constraint_expr_t *expr);
static int define_validatetrans(constraint_expr_t *expr);
static int define_bool(void);
static int define_conditional(cond_expr_t *expr, avrule_t *t_list, avrule_t *f_list );
static cond_expr_t *define_cond_expr(uint32_t expr_type, void *arg1, void* arg2);
static avrule_t *define_cond_pol_list(avrule_t *avlist, avrule_t *stmt);
static avrule_t *define_cond_compute_type(int which);
static avrule_t *define_cond_te_avtab(int which);
static uintptr_t define_cexpr(uint32_t expr_type, uintptr_t arg1, uintptr_t arg2);
static int define_user(void);
static int parse_security_context(context_struct_t *c);
static int define_initial_sid_context(void);
static int define_fs_use(int behavior);
static int define_genfs_context(int has_type);
static int define_fs_context(unsigned int major, unsigned int minor);
static int define_port_context(unsigned int low, unsigned int high);
static int define_netif_context(void);
static int define_ipv4_node_context(unsigned int addr, unsigned int mask);
static int define_ipv6_node_context(void);

typedef int (* require_func_t)();

#line 130 "policy_parse.y"
typedef union {
	unsigned int val;
	uintptr_t valptr;
	void *ptr;
        require_func_t require_func;
} YYSTYPE;
#line 122 "y.tab.c"
#define YYERRCODE 256
#define PATH 257
#define CLONE 258
#define COMMON 259
#define CLASS 260
#define CONSTRAIN 261
#define VALIDATETRANS 262
#define INHERITS 263
#define SID 264
#define ROLE 265
#define ROLES 266
#define TYPEALIAS 267
#define TYPEATTRIBUTE 268
#define TYPE 269
#define TYPES 270
#define ALIAS 271
#define ATTRIBUTE 272
#define BOOL 273
#define IF 274
#define ELSE 275
#define TYPE_TRANSITION 276
#define TYPE_MEMBER 277
#define TYPE_CHANGE 278
#define ROLE_TRANSITION 279
#define RANGE_TRANSITION 280
#define SENSITIVITY 281
#define DOMINANCE 282
#define DOM 283
#define DOMBY 284
#define INCOMP 285
#define CATEGORY 286
#define LEVEL 287
#define RANGE 288
#define MLSCONSTRAIN 289
#define MLSVALIDATETRANS 290
#define USER 291
#define NEVERALLOW 292
#define ALLOW 293
#define AUDITALLOW 294
#define AUDITDENY 295
#define DONTAUDIT 296
#define SOURCE 297
#define TARGET 298
#define SAMEUSER 299
#define FSCON 300
#define PORTCON 301
#define NETIFCON 302
#define NODECON 303
#define FSUSEXATTR 304
#define FSUSETASK 305
#define FSUSETRANS 306
#define GENFSCON 307
#define U1 308
#define U2 309
#define U3 310
#define R1 311
#define R2 312
#define R3 313
#define T1 314
#define T2 315
#define T3 316
#define L1 317
#define L2 318
#define H1 319
#define H2 320
#define NOT 321
#define AND 322
#define OR 323
#define XOR 324
#define CTRUE 325
#define CFALSE 326
#define IDENTIFIER 327
#define USER_IDENTIFIER 328
#define NUMBER 329
#define EQUALS 330
#define NOTEQUAL 331
#define IPV6_ADDR 332
#define MODULE 333
#define VERSION_IDENTIFIER 334
#define REQUIRE 335
#define OPTIONAL 336
const short yylhs[] = {                                        -1,
    0,    0,   24,   28,   33,   21,   23,   23,   38,   25,
   25,   40,   26,   41,   41,   43,   43,   44,   42,   42,
   46,   46,   46,   27,   27,   47,   48,   48,   53,   53,
   54,   49,   49,   50,   50,   56,   56,   57,   57,   51,
   51,   58,   58,   52,   52,   60,   60,   61,   62,   29,
   29,   63,   63,   63,   63,   63,   65,   65,   65,   65,
   64,   64,   64,   64,   64,   64,   64,   64,   72,   73,
   73,   74,   75,   80,   80,   76,   81,   81,   66,    4,
    4,    1,    1,    1,    1,    1,    1,    1,    1,    2,
    3,    3,   11,   11,   11,    9,    9,    9,   10,   10,
   10,   10,    5,    6,    7,    8,   77,   77,   77,   78,
   79,   79,   79,   79,   79,   84,   85,   86,   87,   88,
   68,   68,   69,   70,   71,   13,   13,   12,   12,   31,
   31,   90,   90,   91,   91,   92,   93,   14,   14,   14,
   14,   14,   15,   15,   15,   95,   15,   96,   15,   97,
   15,   99,   15,  100,   15,  101,   15,  102,   15,  103,
   15,  104,   15,   15,  105,   15,  106,   15,   15,  107,
   15,  108,   15,   15,   15,   15,   15,   15,   15,   16,
   16,   17,   17,   17,   17,   30,   30,  110,  110,  109,
  112,  112,   32,   32,  114,   34,   34,  116,  116,  117,
   37,  118,  118,  121,  121,  122,  122,  119,  119,  123,
  123,  124,  120,  120,  125,  125,  126,  126,   35,   35,
  128,  128,  129,  129,  129,   36,   36,  130,  130,  131,
  133,  131,  131,   18,  115,  134,  134,   83,   83,  113,
  113,   59,   59,  135,  136,   55,   55,   55,   55,   55,
  138,   55,  139,  140,   98,   98,   98,   98,   98,  141,
  141,   89,   45,   45,  137,  142,  142,  143,  144,  143,
  143,   39,  111,  145,  146,  146,  146,  146,   94,   94,
   94,   94,   94,  132,   19,  127,   22,  147,  149,  148,
  150,  150,  152,  152,  152,  152,  152,  152,   82,  153,
  153,  154,  154,  155,   20,   20,   20,   20,   20,  156,
  156,  159,   67,  158,  158,  157,  160,  151,  151,
};
const short yylen[] = {                                         2,
    1,    1,    0,    0,    0,   15,    1,    2,    2,    1,
    2,    2,    2,    1,    0,    1,    2,    5,    1,    2,
    5,    4,    7,    1,    0,    5,    1,    2,    4,    3,
    2,    2,    4,    1,    0,    1,    2,    4,    3,    1,
    2,    5,    3,    1,    2,    1,    1,    5,    4,    1,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    3,    5,
    4,    4,    4,    2,    0,    4,    1,    1,    6,    4,
    0,    3,    2,    3,    3,    3,    3,    3,    1,    1,
    2,    0,    1,    1,    1,    7,    7,    7,    1,    1,
    1,    1,    7,    7,    7,    7,    7,    7,    7,    5,
    1,    1,    1,    1,    1,    7,    7,    7,    7,    7,
    5,    3,    4,    5,    4,    1,    2,    3,    5,    1,
    0,    1,    2,    1,    1,    5,    4,    3,    2,    3,
    3,    1,    3,    3,    3,    0,    4,    0,    4,    0,
    4,    0,    4,    0,    4,    0,    4,    0,    4,    0,
    4,    0,    4,    1,    0,    4,    0,    4,    2,    0,
    4,    0,    4,    3,    3,    3,    3,    3,    3,    1,
    1,    1,    1,    1,    1,    1,    2,    1,    1,    6,
    4,    0,    1,    2,    3,    1,    0,    1,    2,    5,
    3,    1,    0,    1,    2,    4,    6,    1,    0,    1,
    2,    4,    1,    0,    1,    2,    4,    4,    1,    0,
    1,    2,    4,    4,    4,    1,    0,    1,    2,    6,
    0,    7,    4,    7,    6,    2,    0,    3,    1,    3,
    1,    1,    3,    1,    1,    1,    1,    1,    2,    2,
    0,    4,    1,    1,    1,    3,    1,    2,    4,    1,
    2,    1,    1,    2,    3,    1,    2,    1,    0,    3,
    1,    1,    1,    1,    1,    2,    2,    2,    1,    1,
    3,    2,    4,    1,    1,    1,    2,    4,    1,    2,
    2,    1,    1,    1,    1,    1,    1,    1,    4,    2,
    1,    2,    3,    3,    1,    1,    1,    1,    1,    1,
    3,    0,    6,    4,    0,    1,    1,    2,    0,
};
const short yydefred[] = {                                      0,
    0,    0,    1,    2,    0,    0,  272,    0,    0,    0,
    7,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  316,  298,  294,  293,  295,  297,   57,   58,   59,   60,
   61,   62,   63,   64,   65,   66,   67,   68,  296,  111,
  112,  113,  114,  115,  287,    0,  292,    0,  289,    0,
    9,    0,    0,    8,   10,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   89,   90,    0,  244,  245,    0,
    0,    0,  248,  247,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  290,  291,    0,
  288,   12,    0,    4,   11,    0,    0,   16,    0,  122,
    0,    0,  242,    0,    0,    0,    0,   69,   77,   78,
    0,    0,    0,    0,    0,    0,    0,    0,   92,  269,
  268,  271,    0,  266,  251,    0,  249,  250,    0,    0,
    0,    0,    0,  126,    0,    0,    0,    0,    0,    0,
    0,  305,  306,  307,  309,  308,    0,    0,  301,    0,
  273,  188,    0,  189,  318,    0,    0,    0,    0,    0,
   19,   17,    0,   31,   72,   73,    0,    0,    0,   71,
   76,   82,    0,    0,    0,   87,   88,    0,    0,  265,
  267,    0,    0,    0,    0,    0,    0,    0,    0,  262,
    0,  123,  127,    0,  125,    0,    0,    0,    0,    0,
  310,    0,  299,  300,  302,    0,  312,    0,    0,    0,
   24,    0,   27,    0,   20,  121,  243,   70,    0,    0,
    0,    0,    0,    0,    0,    0,   99,  100,  101,  102,
   93,   94,   91,   95,  270,  252,    0,    0,    0,  124,
    0,  110,    0,    0,  128,    0,    0,    0,    0,    0,
  304,  303,    0,    0,    0,  263,    0,    0,   56,    0,
   50,   52,   53,   54,   55,    0,    0,   28,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   79,    0,
    0,    0,    0,  238,    0,    0,    0,    0,    0,    0,
  311,    0,    0,  317,  313,    0,   18,  264,   30,    0,
    0,   51,  186,    0,   32,    0,    0,    0,   36,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   92,  107,
  108,  109,  129,  120,  116,  117,  118,  119,    0,  190,
    0,   29,    0,    0,    5,    0,  132,  134,  135,  187,
    0,    0,    0,    0,   40,   37,    0,   21,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  133,   33,   39,    0,    0,    0,    0,    0,   41,
   44,   46,   47,    0,    0,    0,    0,    0,    0,    0,
    0,   80,  191,  314,    0,    0,    0,    0,  164,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  142,    0,    0,  193,   38,   43,
    0,    0,    0,   45,   23,    0,    0,    0,    0,    0,
    0,    0,    0,  183,  184,  185,  180,  181,  182,  169,
  165,  170,  167,  172,    0,  148,  150,    0,    0,  154,
  156,    0,  160,  162,    0,    0,    0,  139,    0,    0,
    0,  137,    0,    0,    0,  194,    0,  198,    0,    0,
    0,   96,   97,   98,  103,  104,  105,  106,  136,    0,
    0,    0,    0,  143,    0,    0,    0,    0,  144,    0,
    0,  145,    0,    0,    0,  174,  178,  175,  179,  176,
  177,  138,  140,    0,    0,  195,  285,    0,    0,    0,
    0,    0,    0,  221,  199,   42,    0,   49,    0,  255,
  166,  253,  254,    0,  257,  171,  168,  173,  274,    0,
  147,  279,    0,  280,  149,  151,  153,  155,  157,  159,
  161,  163,    0,    0,    0,    0,    0,    0,    0,    0,
  228,  222,   48,  260,    0,    0,  258,    0,  275,    0,
    0,  282,    0,    0,    0,    0,    0,    0,    0,    6,
    0,    0,  204,  229,  256,  261,    0,  276,  281,  277,
  278,    0,    0,    0,  200,  223,  224,  225,  284,    0,
    0,    0,    0,    0,  210,  205,  259,  283,    0,    0,
  233,    0,    0,    0,  201,    0,  215,  211,    0,  235,
  231,    0,    0,  206,    0,  286,    0,    0,    0,  216,
  236,    0,  230,    0,  212,    0,    0,    0,  232,  207,
  217,    0,  218,    0,    0,    0,  234,
};
const short yydgoto[] = {                                       2,
   74,   75,  188,  289,  237,  238,  239,  240,  241,  242,
  243,  144,  145,  414,  415,  439,  440,  617,  618,  157,
    3,    4,   10,    5,   63,  104,  220,  168,  270,  311,
  345,  417,  371,  465,  512,  549,  570,   11,   80,   65,
  106,  170,  107,  108,  267,  171,  221,  222,  277,  317,
  354,  379,  223,  112,   81,  318,  319,  355,  114,  381,
  382,  383,  271,   33,   34,   35,   36,   37,   38,   39,
   40,   41,   42,   43,   44,   45,   46,   47,   48,  117,
  121,   49,  198,   50,   51,   52,   53,   54,  520,  346,
  347,  348,  349,  531,  485,  486,  487,  532,  488,  490,
  491,  493,  494,  495,  480,  482,  481,  483,   97,  505,
  164,  303,  199,  418,  506,  467,  468,  571,  593,  605,
  572,  573,  594,  595,  606,  607,  619,  513,  514,  550,
  551,  590,  622,  610,   82,   83,   84,  192,  524,  525,
  555,  133,  134,  189,  534,  560,    6,   55,   60,   56,
   98,   57,  158,  159,  160,  212,   58,  305,  265,  306,
};
const short yysindex[] = {                                   -270,
 -247,    0,    0,    0, -154,  721,    0, -215, -247, -200,
    0, -247, -247, -247, -247, -247, -247,  -38,  -13,  -13,
  -13,  -13,  -13,    7,  -13,  -13,  -13,  -13,  -13,   21,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  639,    0,   29,    0,   96,
    0, -247,  -98,    0,    0,  -25,  -84, -247,  -34,  101,
 -117,  -38,  -38,  -66,    0,    0,   76,    0,    0,  120,
  -13,  -99,    0,    0,  -13,  -13,  -13,  -13,  -94,  -13,
  -13,  -13,  -13,  -13,  297, -106, -107,    0,    0,  721,
    0,    0, -247,    0,    0,  -55,  -43,    0,  -13,    0,
  -13,  167,    0,   33, -247,  190,  177,    0,    0,    0,
  179,  -62,  -37,  -38,  -38,  -38,  -38,  -38,    0,    0,
    0,    0,  -27,    0,    0,  191,    0,    0,  201,  216,
 -247, -247,  -45,    0,  -82,  226,  172,  232,  237,  244,
 -247,    0,    0,    0,    0,    0, -247,  396,    0,  252,
    0,    0,  121,    0,    0,  267,  294,   63, -247,  -55,
    0,    0,  368,    0,    0,    0, -247,  393,  414,    0,
    0,    0,  -62, -152, -141,    0,    0,  -81, -247,    0,
    0, -247,  -13,  -13,  -13,  419,  389,  444,  480,    0,
   -5,    0,    0,  -13,    0,  -13,  -13,  -13,  -13,  -13,
    0,   78,    0,    0,    0,  -13,    0, -247, -247,  826,
    0,  219,    0,  -77,    0,    0,    0,    0,  -13,  -13,
  -13,  -13,  -13,  -13,  -13,  257,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -247, -247, -247,    0,
 -247,    0, -247,  -94,    0,  -13,  -13,  -13,  -13,  -13,
    0,    0, -247,  254,  276,    0, -100,  -36,    0,  754,
    0,    0,    0,    0,    0,  -95,  269,    0, -247, -247,
  -13,  -13,  -13,  -13,  -13,  -13,  -13,  430,    0,  497,
  502,  505,  393,    0,  -80,  506,  514,  517,  521,  522,
    0, -247,  523,    0,    0,  461,    0,    0,    0,  526,
 -158,    0,    0, -247,    0, -247,  300,  269,    0,  467,
  -86,  534,  536,  538,  539,  540,  542,  545,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  319,    0,
  721,    0,  -13,  -13,    0,  245,    0,    0,    0,    0,
  -74,  -32, -247,  -87,    0,    0, -247,    0,  -13,  -13,
  -13,  -13,  -13,  -13,  -13,  386, -247,  484,  -13,  527,
  346,    0,    0,    0,  553,  459,  -13,  -13,  233,    0,
    0,    0,    0,  -72, -247, -247, -247,  -13,  -13,  -13,
  -13,    0,    0,    0,  527,  275, -182, -111,    0,  209,
  209,  209,  275,  209,  209,  209,  209,  209,  275,  275,
  275,  527,  527,  -50,    0, -247, -199,    0,    0,    0,
 -247,  -13,  527,    0,    0,  554,  556,  557,  558,  559,
  560,  561,  -26,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  320,    0,    0,    0,  316,    0,
    0,  315,    0,    0,  126,  311, -138,    0,   -4,  527,
  527,    0, -106,  303,  153,    0,  333,    0,   87,  527,
  -24,    0,    0,    0,    0,    0,    0,    0,    0,   13,
   13,   13,   13,    0,  -11,  -11,  -11,   13,    0,   13,
   13,    0,   13,   13,   13,    0,    0,    0,    0,    0,
    0,    0,    0,  312,  577,    0,    0,  303, -247, -247,
 -247,  332,  153,    0,    0,    0,  116,    0,  -45,    0,
    0,    0,    0,  -83,    0,    0,    0,    0,    0,  221,
    0,    0,  -85,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -247, -106, -106, -106, -106, -247,  341,  332,
    0,    0,    0,    0,  -67,  -45,    0, -104,    0,  -57,
  221,    0,  585, -106,  586,  587,  589,  387, -247,    0,
  352,  341,    0,    0,    0,    0,  -51,    0,    0,    0,
    0,  -47,  115, -247,    0,    0,    0,    0,    0,   62,
  303, -247,  354,  352,    0,    0,    0,    0,  597,   54,
    0,  104, -106, -243,    0,  354,    0,    0, -247,    0,
    0, -106,  303,    0, -106,    0,  303,  612,  328,    0,
    0, -106,    0, -106,    0, -106,  303, -106,    0,    0,
    0,  620,    0,  303,  621,  303,    0,
};
const short yyrindex[] = {                                    410,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   42,    0,    0,    0,    0,
    0,    0,  411,    0,    0,    0,    0,    0,  624,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  582,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   42,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  424,    0,    0,    0,
    0,    0,    0,    0,    0,  624,    0,    0,    0,    0,
    0,  102,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  863,    0,  793,
    0,    0,    0,    0,    0,    0,    0,  626,    0,    0,
    0,    0,  106,   34,  110,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    3,    0,   94,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   69,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  627,  479,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  401,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  148,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  425,    0,    0,    0,    0,    0,    0,  403,    0,  676,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  427,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  900,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   20,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   51,    0,    0,  -35,    0,    0,
    0,   75,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   52,    0,   66,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   70,    0,    0,    0,    0,    0,    0,
    0,  105,   73,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   26,  108,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   32,   30,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  692,   36,    0,    0,    0,    0,  192,    0,
    0,    0,    0,    0,    0,  693,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
  388,    0,  365,    0,    0,    0,    0,    0,    0,    0,
    0,  -89,  441, -250,    0,   80,  168,   79,  -41,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  687,   -1,  641,
    0,    0,    0,  599, -198,  537,    0,    0,    0,    0,
    0,    0,  487,  -64,  443,    0,  392,  357, -109,  334,
    0,    0,  442, -173, -170, -161, -150,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  598,
    0, -147, -348,    0,    0,    0,    0,    0, -142,    0,
  369,    0,    0,   88,    0,    0,    0,  723,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -221,  622,
    0,    0, -168,  299,  607,    0,  250,    0,    0,    0,
    0,  147,    0,  128,    0,  114,  112,    0,  210,    0,
  182,    0,    0,    0,  373,  757,    2,    0,    4,    0,
 -392,    0,  600,    0,  -56,  173,    0,  -78,    0,    0,
  640,  680,    0,  580,    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 1252
const short yytable[] = {                                       8,
  201,   73,  241,  182,  116,  178,  152,   61,  462,  115,
   66,   67,   68,   69,   70,   71,   76,  130,  393,  197,
  575,  166,  309,   77,  307,  203,  374,  314,   79,  202,
   79,  209,  479,  110,  518,  208,  502,  561,  358,  556,
  244,  319,  202,  236,  333,  280,  272,  241,  313,  273,
  373,  220,  425,  255,   79,  203,  129,  575,  274,    9,
  102,  241,    1,   62,  416,  196,  113,  579,   81,  275,
   76,   76,  219,  597,   85,  131,  177,  597,  132,    7,
  137,  321,  441,  138,  294,  507,  442,  152,  616,  350,
  152,  176,  146,  239,  162,   77,  272,  190,  611,  273,
  464,  167,  343,  344,  227,    9,  600,  226,  274,   77,
  141,  530,   78,  113,   78,  351,  158,  254,   59,  275,
  130,  263,   76,   76,   76,   76,   76,   81,  141,   89,
  177,  131,   96,  339,  132,  519,  262,  558,   78,  196,
  197,  293,   83,   95,  433,  516,   84,  240,  613,  210,
   86,  100,  239,  443,  101,  211,   85,  444,  384,  118,
  103,  458,  459,  577,  135,   62,  319,  224,  582,  124,
  143,  126,  471,  146,  553,  227,  146,  127,  128,  500,
  124,  501,  143,   96,  143,  279,  111,  245,  127,  128,
  246,  237,  240,   81,  229,  230,  231,  158,   77,  353,
  158,  377,  378,  310,  169,  203,  240,  119,  120,  503,
  504,  232,  233,  234,  235,  103,  266,  268,  244,  517,
    7,  161,  200,  529,   83,  175,    7,    7,   84,  206,
  205,    7,   86,  115,  111,  180,  111,  181,  111,  598,
    7,  200,  529,  200,  109,  290,  291,  292,  193,  113,
  237,  197,    7,   30,    7,  124,  125,  126,  194,  200,
  621,  301,  368,  127,  128,  308,  241,  127,  128,  200,
  529,  460,  461,  195,  315,  200,  182,  320,  266,  200,
  529,  200,   72,  204,  124,  125,  126,  375,    7,  207,
  241,  152,  127,  128,  208,  460,  461,  460,  461,    7,
  197,  209,  241,  241,  241,  241,  241,  241,  241,  241,
  215,  469,  266,    7,  352,  200,  529,  460,  461,  308,
  197,  197,  197,  197,  197,  197,  197,  203,  203,  241,
  241,  202,  202,   81,  209,   81,   81,   81,  208,  200,
   81,   81,   81,  219,   81,   81,   81,   81,   81,  308,
   81,  376,  220,  220,  220,  266,   85,  239,  220,   81,
   81,   81,   81,   81,   81,  197,  196,  196,  196,  196,
  196,  196,  196,  219,  219,  219,  554,  146,  146,  219,
    7,  557,  308,  426,  427,  428,  216,  554,    7,  161,
  557,  217,  141,  239,  239,  239,  239,  239,  239,  239,
  239,  158,    7,   81,   81,  227,  227,  227,  226,  226,
  226,  240,  576,  554,  463,  576,  218,  580,  554,  113,
  239,  239,  508,   83,   83,   83,  226,   84,   84,   84,
    7,  161,   86,   86,  576,  240,  177,  460,  461,  576,
  580,  200,  529,  496,  497,  498,  251,  240,  240,  240,
  240,  240,  240,  240,  240,  237,  509,  510,  511,  122,
  123,  162,   85,   86,   87,   88,  544,   90,   91,   92,
   93,   94,  228,  559,  240,  240,  562,  250,  315,  445,
  446,  447,  448,  450,  451,  452,  453,  454,  533,  533,
  533,  237,  237,  237,  237,  237,  237,  237,  237,  219,
  276,  578,  252,  581,  559,  343,  344,  545,  546,  547,
  392,  183,  184,  185,  186,  187,  421,  420,  237,  237,
  213,  377,  378,  136,  253,  578,  581,  139,  140,  141,
  142,  288,  146,  147,  148,  149,  150,  315,  437,  438,
  302,  563,  162,  162,  162,  162,  568,  200,  529,  602,
  304,  173,  329,  174,  316,  330,  151,  434,  435,  436,
  331,  152,  162,  332,  334,  153,  413,  591,  154,  155,
  449,  624,  335,  535,  536,  336,  455,  456,  457,  337,
  338,  340,  599,  341,  342,  632,  353,  156,  162,  357,
  603,  359,  635,  360,  637,  361,  362,  363,  612,  364,
  162,  162,  365,  315,  437,  438,  367,  197,  394,  416,
  162,  419,  472,  162,  473,  474,  475,  476,  477,  478,
  162,  246,  162,  246,  162,  246,  162,  489,  484,  492,
  499,  507,  464,  460,  543,  247,  248,  249,  548,  246,
  246,  569,  584,  589,  586,  587,  256,  588,  257,  258,
  259,  260,  261,  592,  609,  151,  604,  627,  264,  616,
  152,  229,  230,  231,  153,  634,  636,  154,  155,    3,
   15,  281,  282,  283,  284,  285,  286,  287,  232,  233,
  234,  235,   75,   14,   74,  192,  156,   35,  131,   34,
  130,  214,  213,  366,  295,  626,   64,   32,  296,  297,
  298,  299,  300,  105,  246,  172,  225,  246,  278,  356,
  380,  312,  424,  179,  372,  466,  515,  163,  596,  620,
   30,  608,  552,  322,  323,  324,  325,  326,  327,  328,
  628,  574,  191,  583,   22,   99,  165,  214,    0,    0,
    0,    0,    0,  315,    0,  315,  315,  315,    0,    0,
  315,  315,  315,    0,  315,  315,  315,  315,  315,    0,
  315,    0,    0,    0,    0,    0,    0,    0,    0,  315,
  315,  315,  315,  315,  315,    0,    0,    0,    0,   32,
    0,    0,    0,    0,    0,  369,  370,    0,    0,    0,
    0,  396,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  385,  386,  387,  388,  389,  390,  391,    0,    0,
    0,  395,  269,  315,  315,    0,    0,    0,    0,  422,
  423,    0,    0,  397,  398,  399,    0,    0,    0,    0,
  429,  430,  431,  432,  400,  401,  402,  403,  404,  405,
  406,  407,  408,  409,  410,  411,  246,  412,    0,    0,
    0,   13,  522,  522,  522,  522,    0,  522,  522,  522,
  522,    0,  522,  522,  470,  522,  522,  522,  246,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  246,  246,
  246,    0,    0,    0,  269,    0,    0,    0,    0,  246,
  246,  246,  246,  246,  246,  246,  246,  246,  246,  246,
  246,    0,  246,   12,    0,   13,   14,   15,  246,    0,
   16,   17,   18,    0,   19,   20,   21,   22,   23,    0,
   24,   25,    0,    0,    0,    0,    0,    0,    0,   96,
   25,   26,   27,   28,   29,   22,    0,    0,    0,    0,
   22,    0,   22,   22,   22,    0,    0,   22,   22,   22,
    0,   22,   22,   22,   22,   22,   22,   22,   26,    0,
    0,    0,    0,    0,    0,    0,    0,   22,   22,   22,
   22,   22,    0,   30,   31,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   12,    0,   13,   14,   15,
    0,    0,   16,   17,   18,    0,   19,   20,   21,   22,
   23,    0,   24,    0,    0,    0,    0,    0,    0,    0,
    0,   22,   25,   26,   27,   28,   29,    0,   12,    0,
   13,   14,   15,    0,    0,   16,   17,   18,    0,   19,
   20,   21,   22,   23,    0,   24,    0,    0,    0,    0,
    0,    0,    0,    0,   96,   25,   26,   27,   28,   29,
    0,    0,    0,    0,    0,   30,   31,   13,    0,   13,
   13,   13,    0,    0,   13,   13,   13,    0,   13,   13,
   13,   13,   13,   13,   13,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   13,   13,   13,   13,   13,   31,
   12,    0,   13,   14,   15,    0,    0,   16,   17,   18,
    0,   19,   20,   21,   22,   23,    0,   24,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   25,   26,   27,
   28,   29,    0,    0,    0,    0,    0,   25,   13,   25,
   25,   25,    0,    0,   25,   25,   25,    0,   25,   25,
   25,   25,   25,    0,   25,    0,    0,    0,    0,    0,
  564,  565,  566,  567,   25,   25,   25,   25,   25,    0,
    0,   31,    0,    0,   26,    0,   26,   26,   26,    0,
  585,   26,   26,   26,    0,   26,   26,   26,   26,   26,
    0,   26,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   26,   26,   26,   26,   26,  601,    0,   25,    0,
    0,    0,  521,  526,  527,  528,    0,    0,  614,  615,
  537,    0,  538,  539,    0,  540,  541,  542,  623,    0,
    0,  625,    0,    0,    0,    0,    0,    0,  629,    0,
  630,    0,  631,    0,  633,   26,  523,  523,  523,  523,
    0,  523,  523,  523,  523,    0,  523,  523,    0,  523,
  523,  523,
};
const short yycheck[] = {                                       1,
  143,   40,    0,   41,   69,  115,   42,    9,   59,   44,
   12,   13,   14,   15,   16,   17,   18,   45,  367,    0,
  125,  100,   59,  123,  125,    0,   59,  123,   42,    0,
   42,    0,   59,   59,   59,    0,   41,  123,  125,  123,
  188,    0,  125,  125,  125,  123,  220,   45,  270,  220,
  125,    0,  125,   59,   42,  145,  123,  125,  220,  260,
   62,   59,  333,  264,  264,    0,   68,  125,    0,  220,
   72,   73,    0,  125,   41,   77,   44,  125,   77,  327,
   82,  280,  265,   82,  253,  329,  269,  123,  332,  311,
  126,   59,   42,    0,   96,  123,  270,  125,   45,  270,
  300,  103,  261,  262,    0,  260,   45,    0,  270,  123,
   41,  123,  126,  115,  126,  314,   42,  123,  334,  270,
   45,   44,  124,  125,  126,  127,  128,   59,   59,  123,
   44,  133,  291,  302,  133,  123,   59,  530,  126,  141,
  142,  251,   41,  123,  395,   59,   41,    0,   45,  151,
   41,  123,   59,  265,   59,  157,  123,  269,  357,   59,
  259,  412,  413,  556,   45,  264,  125,  169,  561,  322,
  265,  324,  423,  123,   59,  177,  126,  330,  331,  318,
  322,  320,  265,  291,  265,  263,  271,  189,  330,  331,
  192,    0,   45,  125,  276,  277,  278,  123,  123,  287,
  126,  289,  290,  268,  260,  295,   59,  325,  326,  460,
  461,  293,  294,  295,  296,  259,  218,  219,  366,  470,
  327,  328,  327,  328,  123,   59,  327,  327,  123,   58,
   59,  327,  123,   44,  271,   59,  271,   59,  271,  125,
  327,  327,  328,  327,  270,  247,  248,  249,   58,  251,
   59,  253,  327,  335,  327,  322,  323,  324,   58,  327,
  609,  263,  341,  330,  331,  267,  264,  330,  331,  327,
  328,  322,  323,   58,  276,  327,  312,  279,  280,  327,
  328,  327,  321,   58,  322,  323,  324,  352,  327,   58,
  288,  327,  330,  331,   58,  322,  323,  322,  323,  327,
  302,   58,  300,  301,  302,  303,  304,  305,  306,  307,
   59,  421,  314,  327,  316,  327,  328,  322,  323,  321,
  301,  302,  303,  304,  305,  306,  307,  302,  303,  327,
  328,  302,  303,  265,  303,  267,  268,  269,  303,  327,
  272,  273,  274,  281,  276,  277,  278,  279,  280,  351,
  282,  353,  301,  302,  303,  357,  323,  264,  307,  291,
  292,  293,  294,  295,  296,  367,  301,  302,  303,  304,
  305,  306,  307,  301,  302,  303,  519,  327,  328,  307,
  327,  524,  384,  385,  386,  387,  266,  530,  327,  328,
  533,  125,  323,  300,  301,  302,  303,  304,  305,  306,
  307,  327,  327,  335,  336,  301,  302,  303,  301,  302,
  303,  264,  555,  556,  416,  558,  123,  560,  561,  421,
  327,  328,  464,  322,  323,  324,   59,  322,  323,  324,
  327,  328,  323,  324,  577,  288,   44,  322,  323,  582,
  583,  327,  328,  318,  319,  320,   58,  300,  301,  302,
  303,  304,  305,  306,  307,  264,  304,  305,  306,   72,
   73,  463,   20,   21,   22,   23,  508,   25,   26,   27,
   28,   29,   59,  530,  327,  328,  533,   59,    0,  400,
  401,  402,  403,  404,  405,  406,  407,  408,  485,  486,
  487,  300,  301,  302,  303,  304,  305,  306,  307,  281,
  282,  558,   59,  560,  561,  261,  262,  509,  510,  511,
  125,  124,  125,  126,  127,  128,   58,   59,  327,  328,
  125,  289,  290,   81,   45,  582,  583,   85,   86,   87,
   88,  275,   90,   91,   92,   93,   94,   59,  330,  331,
  287,  543,  544,  545,  546,  547,  548,  327,  328,  591,
  275,  109,  123,  111,  286,   59,  260,  283,  284,  285,
   59,  265,  564,   59,   59,  269,   40,  569,  272,  273,
  403,  613,   59,  486,  487,   59,  409,  410,  411,   59,
   59,   59,  584,  123,   59,  627,  287,  291,  590,  123,
  592,   58,  634,   58,  636,   58,   58,   58,  600,   58,
  602,  603,   58,  125,  330,  331,  288,  609,  125,  264,
  612,   59,   59,  615,   59,   59,   59,   59,   59,   59,
  622,   40,  624,   42,  626,   44,  628,  312,  309,  315,
  320,  329,  300,  322,   58,  193,  194,  195,  307,   58,
   59,  301,   58,  257,   59,   59,  204,   59,  206,  207,
  208,  209,  210,  302,   58,  260,  303,   46,  216,  332,
  265,  276,  277,  278,  269,   46,   46,  272,  273,  260,
  260,  229,  230,  231,  232,  233,  234,  235,  293,  294,
  295,  296,   59,  260,   59,   59,  291,  287,  264,  287,
  264,    0,    0,  329,  254,  617,   10,   59,  256,  257,
  258,  259,  260,   63,  123,  107,  170,  126,  222,  318,
  354,  270,  379,  116,  346,  417,  467,   96,  572,  606,
  335,  594,  513,  281,  282,  283,  284,  285,  286,  287,
  619,  550,  133,  561,   59,   56,   97,  158,   -1,   -1,
   -1,   -1,   -1,  265,   -1,  267,  268,  269,   -1,   -1,
  272,  273,  274,   -1,  276,  277,  278,  279,  280,   -1,
  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  291,
  292,  293,  294,  295,  296,   -1,   -1,   -1,   -1,   59,
   -1,   -1,   -1,   -1,   -1,  343,  344,   -1,   -1,   -1,
   -1,  265,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  359,  360,  361,  362,  363,  364,  365,   -1,   -1,
   -1,  369,   59,  335,  336,   -1,   -1,   -1,   -1,  377,
  378,   -1,   -1,  297,  298,  299,   -1,   -1,   -1,   -1,
  388,  389,  390,  391,  308,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,  319,  265,  321,   -1,   -1,
   -1,   59,  480,  481,  482,  483,   -1,  485,  486,  487,
  488,   -1,  490,  491,  422,  493,  494,  495,  287,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  297,  298,
  299,   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,  308,
  309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
  319,   -1,  321,  265,   -1,  267,  268,  269,  327,   -1,
  272,  273,  274,   -1,  276,  277,  278,  279,  280,   -1,
  282,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  291,
  292,  293,  294,  295,  296,  260,   -1,   -1,   -1,   -1,
  265,   -1,  267,  268,  269,   -1,   -1,  272,  273,  274,
   -1,  276,  277,  278,  279,  280,  281,  282,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  292,  293,  294,
  295,  296,   -1,  335,  336,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  265,   -1,  267,  268,  269,
   -1,   -1,  272,  273,  274,   -1,  276,  277,  278,  279,
  280,   -1,  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  336,  292,  293,  294,  295,  296,   -1,  265,   -1,
  267,  268,  269,   -1,   -1,  272,  273,  274,   -1,  276,
  277,  278,  279,  280,   -1,  282,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  291,  292,  293,  294,  295,  296,
   -1,   -1,   -1,   -1,   -1,  335,  336,  265,   -1,  267,
  268,  269,   -1,   -1,  272,  273,  274,   -1,  276,  277,
  278,  279,  280,  281,  282,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  292,  293,  294,  295,  296,  336,
  265,   -1,  267,  268,  269,   -1,   -1,  272,  273,  274,
   -1,  276,  277,  278,  279,  280,   -1,  282,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  292,  293,  294,
  295,  296,   -1,   -1,   -1,   -1,   -1,  265,  336,  267,
  268,  269,   -1,   -1,  272,  273,  274,   -1,  276,  277,
  278,  279,  280,   -1,  282,   -1,   -1,   -1,   -1,   -1,
  544,  545,  546,  547,  292,  293,  294,  295,  296,   -1,
   -1,  336,   -1,   -1,  265,   -1,  267,  268,  269,   -1,
  564,  272,  273,  274,   -1,  276,  277,  278,  279,  280,
   -1,  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  292,  293,  294,  295,  296,  590,   -1,  336,   -1,
   -1,   -1,  480,  481,  482,  483,   -1,   -1,  602,  603,
  488,   -1,  490,  491,   -1,  493,  494,  495,  612,   -1,
   -1,  615,   -1,   -1,   -1,   -1,   -1,   -1,  622,   -1,
  624,   -1,  626,   -1,  628,  336,  480,  481,  482,  483,
   -1,  485,  486,  487,  488,   -1,  490,  491,   -1,  493,
  494,  495,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 336
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'",0,"','","'-'","'.'",0,0,0,0,0,0,0,0,0,0,0,"':'",
"';'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'","'~'",0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"PATH","CLONE","COMMON","CLASS","CONSTRAIN","VALIDATETRANS",
"INHERITS","SID","ROLE","ROLES","TYPEALIAS","TYPEATTRIBUTE","TYPE","TYPES",
"ALIAS","ATTRIBUTE","BOOL","IF","ELSE","TYPE_TRANSITION","TYPE_MEMBER",
"TYPE_CHANGE","ROLE_TRANSITION","RANGE_TRANSITION","SENSITIVITY","DOMINANCE",
"DOM","DOMBY","INCOMP","CATEGORY","LEVEL","RANGE","MLSCONSTRAIN",
"MLSVALIDATETRANS","USER","NEVERALLOW","ALLOW","AUDITALLOW","AUDITDENY",
"DONTAUDIT","SOURCE","TARGET","SAMEUSER","FSCON","PORTCON","NETIFCON","NODECON",
"FSUSEXATTR","FSUSETASK","FSUSETRANS","GENFSCON","U1","U2","U3","R1","R2","R3",
"T1","T2","T3","L1","L2","H1","H2","NOT","AND","OR","XOR","CTRUE","CFALSE",
"IDENTIFIER","USER_IDENTIFIER","NUMBER","EQUALS","NOTEQUAL","IPV6_ADDR",
"MODULE","VERSION_IDENTIFIER","REQUIRE","OPTIONAL",
};
const char * const yyrule[] = {
"$accept : policy",
"policy : base_policy",
"policy : module_policy",
"$$1 :",
"$$2 :",
"$$3 :",
"base_policy : $$1 classes initial_sids access_vectors $$2 opt_mls te_rbac users opt_constraints $$3 initial_sid_contexts opt_fs_contexts opt_fs_uses opt_genfs_contexts net_contexts",
"classes : class_def",
"classes : classes class_def",
"class_def : CLASS identifier",
"initial_sids : initial_sid_def",
"initial_sids : initial_sids initial_sid_def",
"initial_sid_def : SID identifier",
"access_vectors : opt_common_perms av_perms",
"opt_common_perms : common_perms",
"opt_common_perms :",
"common_perms : common_perms_def",
"common_perms : common_perms common_perms_def",
"common_perms_def : COMMON identifier '{' identifier_list '}'",
"av_perms : av_perms_def",
"av_perms : av_perms av_perms_def",
"av_perms_def : CLASS identifier '{' identifier_list '}'",
"av_perms_def : CLASS identifier INHERITS identifier",
"av_perms_def : CLASS identifier INHERITS identifier '{' identifier_list '}'",
"opt_mls : mls",
"opt_mls :",
"mls : sensitivities dominance opt_categories levels mlspolicy",
"sensitivities : sensitivity_def",
"sensitivities : sensitivities sensitivity_def",
"sensitivity_def : SENSITIVITY identifier alias_def ';'",
"sensitivity_def : SENSITIVITY identifier ';'",
"alias_def : ALIAS names",
"dominance : DOMINANCE identifier",
"dominance : DOMINANCE '{' identifier_list '}'",
"opt_categories : categories",
"opt_categories :",
"categories : category_def",
"categories : categories category_def",
"category_def : CATEGORY identifier alias_def ';'",
"category_def : CATEGORY identifier ';'",
"levels : level_def",
"levels : levels level_def",
"level_def : LEVEL identifier ':' id_comma_list ';'",
"level_def : LEVEL identifier ';'",
"mlspolicy : mlspolicy_decl",
"mlspolicy : mlspolicy mlspolicy_decl",
"mlspolicy_decl : mlsconstraint_def",
"mlspolicy_decl : mlsvalidatetrans_def",
"mlsconstraint_def : MLSCONSTRAIN names names cexpr ';'",
"mlsvalidatetrans_def : MLSVALIDATETRANS names cexpr ';'",
"te_rbac : te_rbac_decl",
"te_rbac : te_rbac te_rbac_decl",
"te_rbac_decl : te_decl",
"te_rbac_decl : rbac_decl",
"te_rbac_decl : cond_stmt_def",
"te_rbac_decl : optional_block",
"te_rbac_decl : ';'",
"rbac_decl : role_type_def",
"rbac_decl : role_dominance",
"rbac_decl : role_trans_def",
"rbac_decl : role_allow_def",
"te_decl : attribute_def",
"te_decl : type_def",
"te_decl : typealias_def",
"te_decl : typeattribute_def",
"te_decl : bool_def",
"te_decl : transition_def",
"te_decl : range_trans_def",
"te_decl : te_avtab_def",
"attribute_def : ATTRIBUTE identifier ';'",
"type_def : TYPE identifier alias_def opt_attr_list ';'",
"type_def : TYPE identifier opt_attr_list ';'",
"typealias_def : TYPEALIAS identifier alias_def ';'",
"typeattribute_def : TYPEATTRIBUTE identifier id_comma_list ';'",
"opt_attr_list : ',' id_comma_list",
"opt_attr_list :",
"bool_def : BOOL identifier bool_val ';'",
"bool_val : CTRUE",
"bool_val : CFALSE",
"cond_stmt_def : IF cond_expr '{' cond_pol_list '}' cond_else",
"cond_else : ELSE '{' cond_pol_list '}'",
"cond_else :",
"cond_expr : '(' cond_expr ')'",
"cond_expr : NOT cond_expr",
"cond_expr : cond_expr AND cond_expr",
"cond_expr : cond_expr OR cond_expr",
"cond_expr : cond_expr XOR cond_expr",
"cond_expr : cond_expr EQUALS cond_expr",
"cond_expr : cond_expr NOTEQUAL cond_expr",
"cond_expr : cond_expr_prim",
"cond_expr_prim : identifier",
"cond_pol_list : cond_pol_list cond_rule_def",
"cond_pol_list :",
"cond_rule_def : cond_transition_def",
"cond_rule_def : cond_te_avtab_def",
"cond_rule_def : require_block",
"cond_transition_def : TYPE_TRANSITION names names ':' names identifier ';'",
"cond_transition_def : TYPE_MEMBER names names ':' names identifier ';'",
"cond_transition_def : TYPE_CHANGE names names ':' names identifier ';'",
"cond_te_avtab_def : cond_allow_def",
"cond_te_avtab_def : cond_auditallow_def",
"cond_te_avtab_def : cond_auditdeny_def",
"cond_te_avtab_def : cond_dontaudit_def",
"cond_allow_def : ALLOW names names ':' names names ';'",
"cond_auditallow_def : AUDITALLOW names names ':' names names ';'",
"cond_auditdeny_def : AUDITDENY names names ':' names names ';'",
"cond_dontaudit_def : DONTAUDIT names names ':' names names ';'",
"transition_def : TYPE_TRANSITION names names ':' names identifier ';'",
"transition_def : TYPE_MEMBER names names ':' names identifier ';'",
"transition_def : TYPE_CHANGE names names ':' names identifier ';'",
"range_trans_def : RANGE_TRANSITION names names mls_range_def ';'",
"te_avtab_def : allow_def",
"te_avtab_def : auditallow_def",
"te_avtab_def : auditdeny_def",
"te_avtab_def : dontaudit_def",
"te_avtab_def : neverallow_def",
"allow_def : ALLOW names names ':' names names ';'",
"auditallow_def : AUDITALLOW names names ':' names names ';'",
"auditdeny_def : AUDITDENY names names ':' names names ';'",
"dontaudit_def : DONTAUDIT names names ':' names names ';'",
"neverallow_def : NEVERALLOW names names ':' names names ';'",
"role_type_def : ROLE identifier TYPES names ';'",
"role_type_def : ROLE identifier ';'",
"role_dominance : DOMINANCE '{' roles '}'",
"role_trans_def : ROLE_TRANSITION names names identifier ';'",
"role_allow_def : ALLOW names names ';'",
"roles : role_def",
"roles : roles role_def",
"role_def : ROLE identifier_push ';'",
"role_def : ROLE identifier_push '{' roles '}'",
"opt_constraints : constraints",
"opt_constraints :",
"constraints : constraint_decl",
"constraints : constraints constraint_decl",
"constraint_decl : constraint_def",
"constraint_decl : validatetrans_def",
"constraint_def : CONSTRAIN names names cexpr ';'",
"validatetrans_def : VALIDATETRANS names cexpr ';'",
"cexpr : '(' cexpr ')'",
"cexpr : NOT cexpr",
"cexpr : cexpr AND cexpr",
"cexpr : cexpr OR cexpr",
"cexpr : cexpr_prim",
"cexpr_prim : U1 op U2",
"cexpr_prim : R1 role_mls_op R2",
"cexpr_prim : T1 op T2",
"$$4 :",
"cexpr_prim : U1 op $$4 user_names_push",
"$$5 :",
"cexpr_prim : U2 op $$5 user_names_push",
"$$6 :",
"cexpr_prim : U3 op $$6 user_names_push",
"$$7 :",
"cexpr_prim : R1 op $$7 names_push",
"$$8 :",
"cexpr_prim : R2 op $$8 names_push",
"$$9 :",
"cexpr_prim : R3 op $$9 names_push",
"$$10 :",
"cexpr_prim : T1 op $$10 names_push",
"$$11 :",
"cexpr_prim : T2 op $$11 names_push",
"$$12 :",
"cexpr_prim : T3 op $$12 names_push",
"cexpr_prim : SAMEUSER",
"$$13 :",
"cexpr_prim : SOURCE ROLE $$13 names_push",
"$$14 :",
"cexpr_prim : TARGET ROLE $$14 names_push",
"cexpr_prim : ROLE role_mls_op",
"$$15 :",
"cexpr_prim : SOURCE TYPE $$15 names_push",
"$$16 :",
"cexpr_prim : TARGET TYPE $$16 names_push",
"cexpr_prim : L1 role_mls_op L2",
"cexpr_prim : L1 role_mls_op H2",
"cexpr_prim : H1 role_mls_op L2",
"cexpr_prim : H1 role_mls_op H2",
"cexpr_prim : L1 role_mls_op H1",
"cexpr_prim : L2 role_mls_op H2",
"op : EQUALS",
"op : NOTEQUAL",
"role_mls_op : op",
"role_mls_op : DOM",
"role_mls_op : DOMBY",
"role_mls_op : INCOMP",
"users : user_def",
"users : users user_def",
"user_id : identifier",
"user_id : user_identifier",
"user_def : USER user_id ROLES names opt_mls_user ';'",
"opt_mls_user : LEVEL mls_level_def RANGE mls_range_def",
"opt_mls_user :",
"initial_sid_contexts : initial_sid_context_def",
"initial_sid_contexts : initial_sid_contexts initial_sid_context_def",
"initial_sid_context_def : SID identifier security_context_def",
"opt_fs_contexts : fs_contexts",
"opt_fs_contexts :",
"fs_contexts : fs_context_def",
"fs_contexts : fs_contexts fs_context_def",
"fs_context_def : FSCON number number security_context_def security_context_def",
"net_contexts : opt_port_contexts opt_netif_contexts opt_node_contexts",
"opt_port_contexts : port_contexts",
"opt_port_contexts :",
"port_contexts : port_context_def",
"port_contexts : port_contexts port_context_def",
"port_context_def : PORTCON identifier number security_context_def",
"port_context_def : PORTCON identifier number '-' number security_context_def",
"opt_netif_contexts : netif_contexts",
"opt_netif_contexts :",
"netif_contexts : netif_context_def",
"netif_contexts : netif_contexts netif_context_def",
"netif_context_def : NETIFCON identifier security_context_def security_context_def",
"opt_node_contexts : node_contexts",
"opt_node_contexts :",
"node_contexts : node_context_def",
"node_contexts : node_contexts node_context_def",
"node_context_def : NODECON ipv4_addr_def ipv4_addr_def security_context_def",
"node_context_def : NODECON ipv6_addr ipv6_addr security_context_def",
"opt_fs_uses : fs_uses",
"opt_fs_uses :",
"fs_uses : fs_use_def",
"fs_uses : fs_uses fs_use_def",
"fs_use_def : FSUSEXATTR identifier security_context_def ';'",
"fs_use_def : FSUSETASK identifier security_context_def ';'",
"fs_use_def : FSUSETRANS identifier security_context_def ';'",
"opt_genfs_contexts : genfs_contexts",
"opt_genfs_contexts :",
"genfs_contexts : genfs_context_def",
"genfs_contexts : genfs_contexts genfs_context_def",
"genfs_context_def : GENFSCON identifier path '-' identifier security_context_def",
"$$17 :",
"genfs_context_def : GENFSCON identifier path '-' '-' $$17 security_context_def",
"genfs_context_def : GENFSCON identifier path security_context_def",
"ipv4_addr_def : number '.' number '.' number '.' number",
"security_context_def : user_id ':' identifier ':' identifier opt_mls_range_def",
"opt_mls_range_def : ':' mls_range_def",
"opt_mls_range_def :",
"mls_range_def : mls_level_def '-' mls_level_def",
"mls_range_def : mls_level_def",
"mls_level_def : identifier ':' id_comma_list",
"mls_level_def : identifier",
"id_comma_list : identifier",
"id_comma_list : id_comma_list ',' identifier",
"tilde : '~'",
"asterisk : '*'",
"names : identifier",
"names : nested_id_set",
"names : asterisk",
"names : tilde identifier",
"names : tilde nested_id_set",
"$$18 :",
"names : identifier '-' $$18 identifier",
"tilde_push : tilde",
"asterisk_push : asterisk",
"names_push : identifier_push",
"names_push : '{' identifier_list_push '}'",
"names_push : asterisk_push",
"names_push : tilde_push identifier_push",
"names_push : tilde_push '{' identifier_list_push '}'",
"identifier_list_push : identifier_push",
"identifier_list_push : identifier_list_push identifier_push",
"identifier_push : IDENTIFIER",
"identifier_list : identifier",
"identifier_list : identifier_list identifier",
"nested_id_set : '{' nested_id_list '}'",
"nested_id_list : nested_id_element",
"nested_id_list : nested_id_list nested_id_element",
"nested_id_element : identifier",
"$$19 :",
"nested_id_element : '-' $$19 identifier",
"nested_id_element : nested_id_set",
"identifier : IDENTIFIER",
"user_identifier : USER_IDENTIFIER",
"user_identifier_push : USER_IDENTIFIER",
"user_identifier_list_push : user_identifier_push",
"user_identifier_list_push : identifier_list_push user_identifier_push",
"user_identifier_list_push : user_identifier_list_push identifier_push",
"user_identifier_list_push : user_identifier_list_push user_identifier_push",
"user_names_push : names_push",
"user_names_push : user_identifier_push",
"user_names_push : '{' user_identifier_list_push '}'",
"user_names_push : tilde_push user_identifier_push",
"user_names_push : tilde_push '{' user_identifier_list_push '}'",
"path : PATH",
"number : NUMBER",
"ipv6_addr : IPV6_ADDR",
"module_policy : module_def avrules_block",
"module_def : MODULE identifier version_identifier ';'",
"version_identifier : VERSION_IDENTIFIER",
"avrules_block : avrule_decls avrule_user_defs",
"avrule_decls : avrule_decls avrule_decl",
"avrule_decls : avrule_decl",
"avrule_decl : rbac_decl",
"avrule_decl : te_decl",
"avrule_decl : cond_stmt_def",
"avrule_decl : require_block",
"avrule_decl : optional_block",
"avrule_decl : ';'",
"require_block : REQUIRE '{' require_list '}'",
"require_list : require_list require_decl",
"require_list : require_decl",
"require_decl : require_class ';'",
"require_decl : require_decl_def require_id_list ';'",
"require_class : CLASS identifier names",
"require_decl_def : ROLE",
"require_decl_def : TYPE",
"require_decl_def : ATTRIBUTE",
"require_decl_def : USER",
"require_decl_def : BOOL",
"require_id_list : identifier",
"require_id_list : require_id_list ',' identifier",
"$$20 :",
"optional_block : optional_decl '{' avrules_block '}' $$20 optional_else",
"optional_else : else_decl '{' avrules_block '}'",
"optional_else :",
"optional_decl : OPTIONAL",
"else_decl : ELSE",
"avrule_user_defs : user_def avrule_user_defs",
"avrule_user_defs :",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 864 "policy_parse.y"

/* initialize all of the state variables for the scanner/parser */
void init_parser(int pass_number)
{
        policydb_lineno = 1;
        source_lineno = 1;
        policydb_errors = 0;
        pass = pass_number;
}

void yyerror2(char *fmt, ...)
{
        va_list ap;
        va_start(ap, fmt);
        vsnprintf(errormsg, ERRORMSG_LEN, fmt, ap);
        yyerror(errormsg);
        va_end(ap);
}


#define DEBUG 1

static int insert_separator(int push)
{
	int error;

	if (push)
		error = queue_push(id_queue, 0);
	else
		error = queue_insert(id_queue, 0);

	if (error) {
		yyerror("queue overflow");
		return -1;
	}
	return 0;
}

static int insert_id(char *id, int push)
{
	char *newid = 0;
	int error;

	newid = (char *) malloc(strlen(id) + 1);
	if (!newid) {
		yyerror("out of memory");
		return -1;
	}
	strcpy(newid, id);
	if (push)
		error = queue_push(id_queue, (queue_element_t) newid);
	else
		error = queue_insert(id_queue, (queue_element_t) newid);

	if (error) {
		yyerror("queue overflow");
		free(newid);
		return -1;
	}
	return 0;
}

/* Add a rule onto an avtab hash table only if it does not already
 * exist.  (Note that the avtab is discarded afterwards; it will be
 * regenerated during expansion.)  Return 1 if rule was added (or
 * otherwise handled successfully), 0 if it conflicted with something,
 * or -1 on error. */
static int insert_check_type_rule(avrule_t *rule, avtab_t *avtab, cond_av_list_t **list, cond_av_list_t **other)
{
	int ret;

	ret = expand_rule(NULL, policydbp, rule, avtab, list, other, 0);
	if (ret < 0) {
		yyerror("Failed on expanding rule");
        }
	return ret;
}

/* If the identifier has a dot within it and that its first character
   is not a dot then return 1, else return 0. */
static int id_has_dot(char *id)
{
        if (strchr(id, '.') >= id + 1) {
                return 1;
        }
        return 0;
}

static int define_class(void)
{
	char *id = 0;
	class_datum_t *datum = 0;
	int ret;
	uint32_t value;

	if (pass == 2) {
		id = queue_remove(id_queue);
		free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no class name for class definition?");
		return -1;
	}
        if (id_has_dot(id)) {
                free(id);
                yyerror("class identifiers may not contain periods");
                return -1;
        }
	datum = (class_datum_t *) malloc(sizeof(class_datum_t));
	if (!datum) {
		yyerror("out of memory");
		goto bad;
	}
	memset(datum, 0, sizeof(class_datum_t));
        ret = declare_symbol(SYM_CLASSES, id, datum, &value, &value);
        switch(ret) {
        case -3: {
                yyerror("Out of memory!");
                goto bad;
        }
        case -2: {
                yyerror2("duplicate declaration of class %s", id);
                goto bad;
        }
        case -1: {
                yyerror("could not declare class here");
                goto bad;
        }
        case 0:
        case 1: {
                break;
        }
        default: {
                assert(0);  /* should never get here */
        }
        }
        datum->value = value;
	return 0;

      bad:
	if (id)
		free(id);
	if (datum)
		free(datum);
	return -1;
}

static int define_initial_sid(void)
{
	char *id = 0;
	ocontext_t *newc = 0, *c, *head;


	if (pass == 2) {
		id = queue_remove(id_queue);
		free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no sid name for SID definition?");
		return -1;
	}
	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		goto bad;
	}
	memset(newc, 0, sizeof(ocontext_t));
	newc->u.name = id;
	context_init(&newc->context[0]);
	head = policydbp->ocontexts[OCON_ISID];

	for (c = head; c; c = c->next) {
		if (!strcmp(newc->u.name, c->u.name)) {
			sprintf(errormsg, "duplicate initial SID %s", id);
			yyerror(errormsg);
			goto bad;
		}
	}

	if (head) {
		newc->sid[0] = head->sid[0] + 1;
	} else {
		newc->sid[0] = 1;
	}
	newc->next = head;
	policydbp->ocontexts[OCON_ISID] = newc;

	return 0;

      bad:
	if (id)
		free(id);
	if (newc)
		free(newc);
	return -1;
}

static int define_common_perms(void)
{
	char *id = 0, *perm = 0;
	common_datum_t *comdatum = 0;
	perm_datum_t *perdatum = 0;
	int ret;


	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no common name for common perm definition?");
		return -1;
	}
        comdatum = hashtab_search(policydbp->p_commons.table, id);
        if (comdatum) {
                snprintf(errormsg, ERRORMSG_LEN,
                         "duplicate declaration for common %s\n", id);
                yyerror(errormsg);
                return -1;
        }
	comdatum = (common_datum_t *) malloc(sizeof(common_datum_t));
	if (!comdatum) {
		yyerror("out of memory");
		goto bad;
	}
	memset(comdatum, 0, sizeof(common_datum_t));
	ret = hashtab_insert(policydbp->p_commons.table,
			 (hashtab_key_t) id, (hashtab_datum_t) comdatum);

	if (ret == HASHTAB_PRESENT) {
		yyerror("duplicate common definition");
		goto bad;
	}
	if (ret == HASHTAB_OVERFLOW) {
		yyerror("hash table overflow");
		goto bad;
	}
        comdatum->value = policydbp->p_commons.nprim + 1;
	if (symtab_init(&comdatum->permissions, PERM_SYMTAB_SIZE)) {
		yyerror("out of memory");
		goto bad;
	}
        policydbp->p_commons.nprim++;
	while ((perm = queue_remove(id_queue))) {
		perdatum = (perm_datum_t *) malloc(sizeof(perm_datum_t));
		if (!perdatum) {
			yyerror("out of memory");
			goto bad_perm;
		}
		memset(perdatum, 0, sizeof(perm_datum_t));
		perdatum->value = comdatum->permissions.nprim + 1;

		if (perdatum->value > (sizeof(sepol_access_vector_t) * 8)) {
			yyerror("too many permissions to fit in an access vector");
			goto bad_perm;
		}
		ret = hashtab_insert(comdatum->permissions.table,
				     (hashtab_key_t) perm,
				     (hashtab_datum_t) perdatum);

		if (ret == HASHTAB_PRESENT) {
			sprintf(errormsg, "duplicate permission %s in common %s",
				perm, id);
			yyerror(errormsg);
			goto bad_perm;
		}
		if (ret == HASHTAB_OVERFLOW) {
			yyerror("hash table overflow");
			goto bad_perm;
		}
                comdatum->permissions.nprim++;
	}

	return 0;

      bad:
	if (id)
		free(id);
	if (comdatum)
		free(comdatum);
	return -1;

      bad_perm:
	if (perm)
		free(perm);
	if (perdatum)
		free(perdatum);
	return -1;
}


static int define_av_perms(int inherits)
{
	char *id;
	class_datum_t *cladatum;
	common_datum_t *comdatum;
	perm_datum_t *perdatum = 0, *perdatum2 = 0;
	int ret;


	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no tclass name for av perm definition?");
		return -1;
	}
	cladatum = (class_datum_t *) hashtab_search(policydbp->p_classes.table,
						    (hashtab_key_t) id);
	if (!cladatum) {
		sprintf(errormsg, "class %s is not defined", id);
		yyerror(errormsg);
		goto bad;
	}
	free(id);

	if (cladatum->comdatum || cladatum->permissions.nprim) {
		yyerror("duplicate access vector definition");
		return -1;
	}
	if (symtab_init(&cladatum->permissions, PERM_SYMTAB_SIZE)) {
		yyerror("out of memory");
		return -1;
	}
	if (inherits) {
		id = (char *) queue_remove(id_queue);
		if (!id) {
			yyerror("no inherits name for access vector definition?");
			return -1;
		}
		comdatum = (common_datum_t *) hashtab_search(policydbp->p_commons.table,
						     (hashtab_key_t) id);

		if (!comdatum) {
			sprintf(errormsg, "common %s is not defined", id);
			yyerror(errormsg);
			goto bad;
		}
		cladatum->comkey = id;
		cladatum->comdatum = comdatum;

		/*
		 * Class-specific permissions start with values 
		 * after the last common permission.
		 */
		cladatum->permissions.nprim += comdatum->permissions.nprim;
	}
	while ((id = queue_remove(id_queue))) {
		perdatum = (perm_datum_t *) malloc(sizeof(perm_datum_t));
		if (!perdatum) {
			yyerror("out of memory");
			goto bad;
		}
		memset(perdatum, 0, sizeof(perm_datum_t));
		perdatum->value = ++cladatum->permissions.nprim;

		if (perdatum->value > (sizeof(sepol_access_vector_t) * 8)) {
			yyerror("too many permissions to fit in an access vector");
			goto bad;
		}
		if (inherits) {
			/*
			 * Class-specific permissions and 
			 * common permissions exist in the same
			 * name space.
			 */
			perdatum2 = (perm_datum_t *) hashtab_search(cladatum->comdatum->permissions.table,
						     (hashtab_key_t) id);
			if (perdatum2) {
				sprintf(errormsg, "permission %s conflicts with an inherited permission", id);
				yyerror(errormsg);
				goto bad;
			}
		}
		ret = hashtab_insert(cladatum->permissions.table,
				     (hashtab_key_t) id,
				     (hashtab_datum_t) perdatum);

		if (ret == HASHTAB_PRESENT) {
			sprintf(errormsg, "duplicate permission %s", id);
			yyerror(errormsg);
			goto bad;
		}
		if (ret == HASHTAB_OVERFLOW) {
			yyerror("hash table overflow");
			goto bad;
		}
                if (add_perm_to_class(perdatum->value, cladatum->value)) {
                        yyerror("out of memory");
                        goto bad;
                }
	}

	return 0;

      bad:
	if (id)
		free(id);
	if (perdatum)
		free(perdatum);
	return -1;
}


static int define_sens(void)
{
	char *id;
	mls_level_t *level = 0;
	level_datum_t *datum = 0, *aliasdatum = 0;
	int ret;
        uint32_t value;  /* dummy variable -- its value is never used */

	if (!mlspol) {
		yyerror("sensitivity definition in non-MLS configuration");
		return -1;
	}

	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no sensitivity name for sensitivity definition?");
		return -1;
	}
	if (id_has_dot(id)) {
		yyerror("sensitivity identifiers may not contain periods");
		goto bad;
	}
	level = (mls_level_t *) malloc(sizeof(mls_level_t));
	if (!level) {
		yyerror("out of memory");
		goto bad;
	}
	memset(level, 0, sizeof(mls_level_t));
	level->sens = 0;	/* actual value set in define_dominance */
	ebitmap_init(&level->cat);	/* actual value set in define_level */

	datum = (level_datum_t *) malloc(sizeof(level_datum_t));
	if (!datum) {
		yyerror("out of memory");
		goto bad;
	}
	memset(datum, 0, sizeof(level_datum_t));
	datum->isalias = FALSE;
	datum->level = level;

        ret = declare_symbol(SYM_LEVELS, id, datum, &value, &value);
        switch(ret) {
        case -3: {
                yyerror("Out of memory!");
                goto bad;
        }
        case -2: {
                yyerror("duplicate declaration of sensitivity level");
                goto bad;
        }
        case -1: {
                yyerror("could not declare sensitivity level here");
                goto bad;
        }
        case 0:
        case 1: {
                break;
        }
        default: {
                assert(0);  /* should never get here */
        }
        }
        
	while ((id = queue_remove(id_queue))) {
		if (id_has_dot(id)) {
			yyerror("sensitivity aliases may not contain periods");
			goto bad_alias;
		}
		aliasdatum = (level_datum_t *) malloc(sizeof(level_datum_t));
		if (!aliasdatum) {
			yyerror("out of memory");
			goto bad_alias;
		}
		memset(aliasdatum, 0, sizeof(level_datum_t));
		aliasdatum->isalias = TRUE;
		aliasdatum->level = level;

                ret = declare_symbol(SYM_LEVELS, id, aliasdatum, NULL, &value);
                switch(ret) {
                case -3: {
                        yyerror("Out of memory!");
                        goto bad_alias;
                }
                case -2: {
                        yyerror("duplicate declaration of sensitivity alias");
                        goto bad_alias;
                }
                case -1: {
                        yyerror("could not declare sensitivity alias here");
                        goto bad_alias;
                }
                case 0:
                case 1: {
                        break;
                }
                default: {
                        assert(0);  /* should never get here */
                }
                }
	}

	return 0;

      bad:
	if (id)
		free(id);
	if (level)
		free(level);
	if (datum)
		free(datum);
	return -1;

      bad_alias:
	if (id)
		free(id);
	if (aliasdatum)
		free(aliasdatum);
	return -1;
}

static int define_dominance(void)
{
	level_datum_t *datum;
	int order;
	char *id;

	if (!mlspol) {
		yyerror("dominance definition in non-MLS configuration");
		return -1;
	}

	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	order = 0;
	while ((id = (char *) queue_remove(id_queue))) {
		datum = (level_datum_t *) hashtab_search(policydbp->p_levels.table,
						     (hashtab_key_t) id);
		if (!datum) {
			sprintf(errormsg, "unknown sensitivity %s used in dominance definition", id);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		if (datum->level->sens != 0) {
			sprintf(errormsg, "sensitivity %s occurs multiply in dominance definition", id);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		datum->level->sens = ++order;

		/* no need to keep sensitivity name */
		free(id);
	}

	if (order != policydbp->p_levels.nprim) {
		yyerror("all sensitivities must be specified in dominance definition");
		return -1;
	}
	return 0;
}

static int define_category(void)
{
	char *id;
	cat_datum_t *datum = 0, *aliasdatum = 0;
	int ret;
        uint32_t value;

	if (!mlspol) {
		yyerror("category definition in non-MLS configuration");
		return -1;
	}

	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no category name for category definition?");
		return -1;
	}
	if (id_has_dot(id)) {
		yyerror("category identifiers may not contain periods");
		goto bad;
	}
	datum = (cat_datum_t *) malloc(sizeof(cat_datum_t));
	if (!datum) {
		yyerror("out of memory");
		goto bad;
	}
	memset(datum, 0, sizeof(cat_datum_t));
	datum->isalias = FALSE;

        ret = declare_symbol(SYM_CATS, id, datum, &value, &value);
        switch(ret) {
        case -3: {
                yyerror("Out of memory!");
                goto bad;
        }
        case -2: {
                yyerror("duplicate declaration of category");
                goto bad;
        }
        case -1: {
                yyerror("could not declare category here");
                goto bad;
        }
        case 0:
        case 1: {
                break;
        }
        default: {
                assert(0);  /* should never get here */
        }
        }
        datum->value = value;

	while ((id = queue_remove(id_queue))) {
		if (id_has_dot(id)) {
			yyerror("category aliases may not contain periods");
			goto bad_alias;
		}
		aliasdatum = (cat_datum_t *) malloc(sizeof(cat_datum_t));
		if (!aliasdatum) {
			yyerror("out of memory");
			goto bad_alias;
		}
		memset(aliasdatum, 0, sizeof(cat_datum_t));
		aliasdatum->isalias = TRUE;
		aliasdatum->value = datum->value;

                ret = declare_symbol(SYM_CATS, id, aliasdatum, NULL, &datum->value);
                switch(ret) {
                case -3: {
                        yyerror("Out of memory!");
                        goto bad_alias;
                }
                case -2: {
                        yyerror("duplicate declaration of category aliases");
                        goto bad_alias;
                }
                case -1: {
                        yyerror("could not declare category aliases here");
                        goto bad_alias;
                }
                case 0:
                case 1: {
                        break;
                }
                default: {
                        assert(0);  /* should never get here */
                }
                }
	}

	return 0;

      bad:
	if (id)
		free(id);
	if (datum)
		free(datum);
	return -1;

      bad_alias:
	if (id)
		free(id);
	if (aliasdatum)
		free(aliasdatum);
	return -1;
}

static int clone_level(hashtab_key_t key, hashtab_datum_t datum, void *arg)
{
	level_datum_t *levdatum = (level_datum_t *) datum;
	mls_level_t *level = (mls_level_t *) arg, *newlevel;

	if (levdatum->level == level) {
		levdatum->defined = 1;
		if (!levdatum->isalias)
			return 0;
		newlevel = (mls_level_t *) malloc(sizeof(mls_level_t));
		if (!newlevel)
			return -1;
		if (mls_level_cpy(newlevel, level)) {
			free(newlevel);
			return -1;
		}
		levdatum->level = newlevel;
	}
	return 0;
}

static int define_level(void)
{
	char *id;
	level_datum_t *levdatum;

	if (!mlspol) {
		yyerror("level definition in non-MLS configuration");
		return -1;
	}

	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no level name for level definition?");
		return -1;
	}
	levdatum = (level_datum_t *) hashtab_search(policydbp->p_levels.table,
						    (hashtab_key_t) id);
	if (!levdatum) {
		sprintf(errormsg, "unknown sensitivity %s used in level definition", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	if (ebitmap_length(&levdatum->level->cat)) {
		sprintf(errormsg, "sensitivity %s used in multiple level definitions", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	free(id);

	levdatum->defined = 1;

	while ((id = queue_remove(id_queue))) {
		cat_datum_t *cdatum;
		int range_start, range_end, i;

		if (id_has_dot(id)) {
			char *id_start = id;
			char *id_end = strchr(id, '.');

			*(id_end++) = '\0';

			cdatum = (cat_datum_t *)hashtab_search(policydbp->p_cats.table,
			                                       (hashtab_key_t)id_start);
			if (!cdatum) {
				sprintf(errormsg, "unknown category %s", id_start);
				yyerror(errormsg);
				free(id);
				return -1;
			}
			range_start = cdatum->value - 1;
			cdatum = (cat_datum_t *)hashtab_search(policydbp->p_cats.table,
			                                       (hashtab_key_t)id_end);
			if (!cdatum) {
				sprintf(errormsg, "unknown category %s", id_end);
				yyerror(errormsg);
				free(id);
				return -1;
			}
			range_end = cdatum->value - 1;

			if (range_end < range_start) {
				sprintf(errormsg, "category range is invalid");
				yyerror(errormsg);
				free(id);
				return -1;
			}
		} else {
			cdatum = (cat_datum_t *)hashtab_search(policydbp->p_cats.table,
			                                       (hashtab_key_t)id);
			range_start = range_end = cdatum->value - 1;
		}

		for (i = range_start; i <= range_end; i++) {
			if (ebitmap_set_bit(&levdatum->level->cat, i, TRUE)) {
				yyerror("out of memory");
				free(id);
				return -1;
			}
		}

		free(id);
	}

	if (hashtab_map(policydbp->p_levels.table, clone_level, levdatum->level)) {
		yyerror("out of memory");
		return -1;
	}

	return 0;
}

static int define_attrib(void)
{
	if (pass == 2) {
		free(queue_remove(id_queue));
		return 0;
	}

        if (declare_type(TRUE, TRUE) == NULL) {
                return -1;
        }
        return 0;
}

static int add_aliases_to_type(type_datum_t *type)
{
        char *id;
        type_datum_t *aliasdatum = NULL;
        int ret;
	while ((id = queue_remove(id_queue))) {
                if (id_has_dot(id)) {
                        free(id);
                        yyerror("type alias identifiers may not contain periods");
                        return -1;
                }
		aliasdatum = (type_datum_t *) malloc(sizeof(type_datum_t));
		if (!aliasdatum) {
                        free(id);
			yyerror("Out of memory!");
			return -1;
		}
		memset(aliasdatum, 0, sizeof(type_datum_t));
		aliasdatum->value = type->value;

                ret = declare_symbol(SYM_TYPES, id, aliasdatum,
                                     NULL, &aliasdatum->value);
                switch(ret) {
                case -3: {
                        yyerror("Out of memory!");
                        goto cleanup;
                }
                case -2: {
                        yyerror2("duplicate declaration of alias %s", id);
                        goto cleanup;
                }
                case -1: {
                        yyerror("could not declare alias here");
                        goto cleanup;
                }
                case 0:
                case 1: {
                        break;
                }
                default: {
                        assert(0);  /* should never get here */
                }
                }
	}
	return 0;
 cleanup:
	free(id);
        type_datum_destroy(aliasdatum);
        free(aliasdatum);
        return -1;
}

static int define_typealias(void)
{
	char *id;
	type_datum_t *t;

	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no type name for typealias definition?");
		return -1;
	}

        if (!is_id_in_scope(SYM_TYPES, id)) {
                yyerror2("type %s is not within scope", id);
                free(id);
                return -1;
        }
	t = hashtab_search(policydbp->p_types.table, id);
	if (!t || t->isattr) {
		sprintf(errormsg, "unknown type %s, or it was already declared as an attribute", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
        return add_aliases_to_type(t);
}

static int define_typeattribute(void)
{
	char *id;
	type_datum_t *t, *attr;

	if (pass == 2) {
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no type name for typeattribute definition?");
		return -1;
	}

        if (!is_id_in_scope(SYM_TYPES, id)) {
                yyerror2("type %s is not within scope", id);
                free(id);
                return -1;
        }
	t = hashtab_search(policydbp->p_types.table, id);
	if (!t || t->isattr) {
		sprintf(errormsg, "unknown type %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
        if ((t = get_local_type(id, t->value)) == NULL) {
                yyerror("Out of memory!");
                return -1;
        }

	while ((id = queue_remove(id_queue))) {
                if (!is_id_in_scope(SYM_TYPES, id)) {
                        yyerror2("attribute %s is not within scope", id);
                        free(id);
                        return -1;
                }
		attr = hashtab_search(policydbp->p_types.table, id);
                if (!attr) {
			sprintf(errormsg, "attribute %s is not declared", id);
			/* treat it as a fatal error */
			yyerror(errormsg);
			free(id);
			return -1;
		}

		if (!attr->isattr) {
			sprintf(errormsg, "%s is a type, not an attribute", id);
			yyerror(errormsg);
			free(id);
			return -1;
		}

		free(id);

		if (ebitmap_set_bit(&attr->types, (t->value - 1), TRUE)) {
			yyerror("out of memory");
			return -1;
		}
	}

	return 0;
}

static int define_type(int alias)
{
	char *id;
	type_datum_t *datum, *attr;
	int newattr = 0;

	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		if (alias) {
			while ((id = queue_remove(id_queue))) 
				free(id);
		}
		return 0;
	}

        if ((datum = declare_type(TRUE, FALSE)) == NULL) {
                return -1;
        }

	if (alias) {
                if (add_aliases_to_type(datum) == -1) {
                        return -1;
                }
	}

	while ((id = queue_remove(id_queue))) {
                if (!is_id_in_scope(SYM_TYPES, id)) {
                        yyerror2("attribute %s is not within scope", id);
                        free(id);
                        return -1;
                }
		attr = hashtab_search(policydbp->p_types.table, id);
		if (!attr) {
			sprintf(errormsg, "attribute %s is not declared", id);

			/* treat it as a fatal error */
			yyerror(errormsg);
			return -1;
		} else {
			newattr = 0;
		}

		if (!attr->isattr) {
			sprintf(errormsg, "%s is a type, not an attribute", id);
			yyerror(errormsg);
			return -1;
		}

                if ((attr = get_local_type(id, attr->value)) == NULL) {
                        yyerror("Out of memory!");
                        return -1;
                }

		if (ebitmap_set_bit(&attr->types, datum->value - 1, TRUE)) {
			yyerror("Out of memory");
			return -1;
		}
	}

	return 0;
}

struct val_to_name {
	unsigned int val;
	char *name;
};

/* Adds a type, given by its textual name, to a typeset.  If *add is
   0, then add the type to the negative set; otherwise if *add is 1
   then add it to the positive side. */
static int set_types(type_set_t *set,
		     char *id,
		     int *add, 
		     char starallowed)
{
	type_datum_t *t;

	if (strcmp(id, "*") == 0) {
		if (!starallowed) {
			yyerror("* not allowed in this type of rule");
			return -1;
		}
                /* set TYPE_STAR flag */
                set->flags = TYPE_STAR;
		free(id);
                *add = 1;
		return 0;
	}

	if (strcmp(id, "~") == 0) {
		if (!starallowed) {
			yyerror("~ not allowed in this type of rule");
			return -1;
		}
		/* complement the set */
                set->flags = TYPE_COMP;
		free(id);
                *add = 1;
		return 0;
	}

	if (strcmp(id, "-") == 0) {
		*add = 0;
		free(id);
		return 0;
	}	

        if (!is_id_in_scope(SYM_TYPES, id)) {
                yyerror2("type %s is not within scope", id);
                free(id);
                return -1;
        }
	t = hashtab_search(policydbp->p_types.table, id);
	if (!t) {
		snprintf(errormsg, ERRORMSG_LEN, "unknown type %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}

        if (*add == 0) {
                if (ebitmap_set_bit(&set->negset, t->value - 1, TRUE)) 
			goto oom;
        }
        else {
                if (ebitmap_set_bit(&set->types, t->value - 1, TRUE))
			goto oom;
        }
	free(id);
	*add = 1;
	return 0;
oom:
	yyerror("Out of memory");
	free(id);
	return -1;
}

static int define_compute_type_helper(int which, avrule_t **rule)
{
	char *id;
	type_datum_t *datum;
	class_datum_t *cladatum;
	ebitmap_t tclasses;
	ebitmap_node_t *node;
	avrule_t *avrule;
	class_perm_node_t *perm;
	int i, add = 1;

	avrule = malloc(sizeof(avrule_t));
	if (!avrule) {
		yyerror("out of memory");
		return -1;
	}
	avrule_init(avrule);
        avrule->specified = which;
        avrule->line = policydb_lineno;

        while ((id = queue_remove(id_queue))) {
                if (set_types(&avrule->stypes, id, &add, 0))
                        return -1;
        }
        add = 1;
	while ((id = queue_remove(id_queue))) {
		if (set_types(&avrule->ttypes, id, &add, 0))
			return -1;
	}

        ebitmap_init(&tclasses);
	while ((id = queue_remove(id_queue))) {
                if (!is_id_in_scope(SYM_CLASSES, id)) {
                        yyerror2("class %s is not within scope", id);
                        free(id);
                        goto bad;
                }
		cladatum = hashtab_search(policydbp->p_classes.table, id);
		if (!cladatum) {
			sprintf(errormsg, "unknown class %s", id);
			yyerror(errormsg);
			goto bad;
		}
		if (ebitmap_set_bit(&tclasses, cladatum->value - 1, TRUE)) {
			yyerror("Out of memory");
			goto bad;
		}
		free(id);
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no newtype?");
		goto bad;
	}
        if (!is_id_in_scope(SYM_TYPES, id)) {
                yyerror2("type %s is not within scope", id);
                free(id);
                goto bad;
        }
	datum = (type_datum_t *) hashtab_search(policydbp->p_types.table,
						(hashtab_key_t) id);
	if (!datum || datum->isattr) {
		sprintf(errormsg, "unknown type %s", id);
		yyerror(errormsg);
		goto bad;
	}
	
	ebitmap_for_each_bit(&tclasses, node, i) {
		if (ebitmap_node_get_bit(node, i)) {
			perm = malloc(sizeof(class_perm_node_t));
			if (!perm) {
				yyerror("out of memory"); 
				return -1;
			}               
			class_perm_node_init(perm);
			perm->class = i + 1;
			perm->data = datum->value;
			perm->next = avrule->perms;
			avrule->perms = perm;
		}               
	}
	ebitmap_destroy(&tclasses);
        
        *rule = avrule;
	return 0;

      bad:
      	avrule_destroy(avrule);
      	free(avrule);
	return -1;
}

static int define_compute_type(int which)
{
	char *id;
	avrule_t *avrule;
        int retval;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		id = queue_remove(id_queue);
		free(id);
		return 0;
	}
	
	if (define_compute_type_helper(which, &avrule))
		return -1;
	
	retval = insert_check_type_rule(avrule, &policydbp->te_avtab, NULL, NULL);
	switch (retval) {
        case 1: {
                /* append this avrule to the end of the current rules list */
                append_avrule(avrule);
                return 0;
        }
        case 0: {
                /* rule conflicted, so don't actually add this rule */
                avrule_destroy(avrule);
                free(avrule);
                return 0;
        }
        case -1: {
                avrule_destroy(avrule);
                free(avrule);
                return -1;
        }
        default: {
                assert(0); /* should never get here */
        }
        }
}

static avrule_t *define_cond_compute_type(int which)
{
	char *id;
	avrule_t *avrule;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		id = queue_remove(id_queue);
		free(id);
		return (avrule_t*)1;
	}
	
	if (define_compute_type_helper(which, &avrule))
		return COND_ERR;

	return avrule;
}

static int define_bool(void)
{
	char *id, *bool_value;
	cond_bool_datum_t *datum;
	int ret;
	uint32_t value;

	if (pass == 2) {
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no identifier for bool definition?");
		return -1;
	}
        if (id_has_dot(id)) {
                free(id);
                yyerror("boolean identifiers may not contain periods");
                return -1;
        }
	datum = (cond_bool_datum_t *) malloc(sizeof(cond_bool_datum_t));
	if (!datum) {
		yyerror("out of memory");
		free(id);
		return -1;
	}
	memset(datum, 0, sizeof(cond_bool_datum_t));
        ret = declare_symbol(SYM_BOOLS, id, datum, &value, &value);
        switch(ret) {
        case -3: {
                yyerror("Out of memory!");
                goto cleanup;
        }
        case -2: {
                yyerror2("duplicate declaration of boolean %s", id);
                goto cleanup;
        }
        case -1: {
                yyerror("could not declare boolean here");
                goto cleanup;
                }
        case 0:
        case 1: {
                break;
        }
        default: {
                assert(0);  /* should never get here */
        }
        }
	datum->value = value;

        bool_value = (char *) queue_remove(id_queue);
	if (!bool_value) {
		yyerror("no default value for bool definition?");
		free(id);
		return -1;
	}

	datum->state = (int)(bool_value[0] == 'T') ? 1 : 0;
	return 0;
 cleanup:
        cond_destroy_bool(id, datum, NULL);
        return -1;
}

static avrule_t *define_cond_pol_list(avrule_t *avlist, avrule_t *sl)
{
	if (pass == 1) {
		/* return something so we get through pass 1 */
		return (avrule_t *)1;
	}

	if (sl == NULL) {
		/* This is a require block, return previous list */
		return avlist;
	}

        /* prepend the new avlist to the pre-existing one */
        sl->next = avlist;
        return sl;
}

static int define_te_avtab_helper(int which, avrule_t **rule)
{
	char *id;
	class_datum_t *cladatum;
	perm_datum_t *perdatum = NULL;
	class_perm_node_t *perms, *tail = NULL, *cur_perms = NULL;
	ebitmap_t tclasses;
	ebitmap_node_t *node;
	avrule_t *avrule;
	unsigned int i;
	int add = 1, ret = 0;
	int suppress = 0;

	avrule = (avrule_t*)malloc(sizeof(avrule_t));
	if (!avrule) {
		yyerror("memory error");
		ret = -1;
		goto out;
	}
	avrule_init(avrule);
        avrule->specified = which;
        avrule->line = policydb_lineno;
	
	while ((id = queue_remove(id_queue))) {
		if (set_types(&avrule->stypes, id, &add, which == AVRULE_NEVERALLOW? 1 : 0 )) {
			ret = -1;
			goto out;
		}
	}
        add = 1;
	while ((id = queue_remove(id_queue))) {
		if (strcmp(id, "self") == 0) {
			free(id);
			avrule->flags |= RULE_SELF;
			continue;
		}
		if (set_types(&avrule->ttypes, id, &add, which == AVRULE_NEVERALLOW? 1 : 0 )) {
			ret = -1;
			goto out;
		}
	}

	ebitmap_init(&tclasses);
	while ((id = queue_remove(id_queue))) {
                if (!is_id_in_scope(SYM_CLASSES, id)) {
                        yyerror2("class %s is not within scope", id);
                        ret = -1;
                        goto out;
                }
		cladatum = hashtab_search(policydbp->p_classes.table, id);
		if (!cladatum) 	{
			sprintf(errormsg, "unknown class %s used in rule", id);
			yyerror(errormsg);
			ret = -1;
			goto out;
		}
		if (ebitmap_set_bit(&tclasses, cladatum->value - 1, TRUE)) {
			yyerror("Out of memory");
			ret = -1;
			goto out;
		}
		free(id);
	}

	perms = NULL;
	ebitmap_for_each_bit(&tclasses, node, i) {
		if (!ebitmap_node_get_bit(node, i))
			continue;
		cur_perms = (class_perm_node_t *)malloc(sizeof(class_perm_node_t));
		if (!cur_perms) {
			yyerror("out of memory");
			ret = -1;
			goto out;
		}
		class_perm_node_init(cur_perms);
		cur_perms->class = i + 1;
		if (!perms)
			perms = cur_perms;
		if (tail)
			tail->next = cur_perms;
		tail = cur_perms;
	}

	while ((id = queue_remove(id_queue))) {
		cur_perms = perms;
		ebitmap_for_each_bit(&tclasses, node, i) {
			if (!ebitmap_node_get_bit(node, i))
				continue;
			cladatum = policydbp->class_val_to_struct[i];

			if (strcmp(id, "*") == 0) {
				/* set all permissions in the class */
				cur_perms->data = ~0U;
				goto next;
			}

			if (strcmp(id, "~") == 0) {
				/* complement the set */
				if (which == AVRULE_DONTAUDIT) 
					yywarn("dontaudit rule with a ~?");
				cur_perms->data = ~cur_perms->data;
				goto next;
			}

			perdatum = hashtab_search(cladatum->permissions.table, id);
			if (!perdatum) {
				if (cladatum->comdatum) {
					perdatum = hashtab_search(cladatum->comdatum->permissions.table,
								  id);
				}
			}
			if (!perdatum) {
				sprintf(errormsg, "permission %s is not defined for class %s", id, policydbp->p_class_val_to_name[i]);
				if (!suppress)
				  yyerror(errormsg);
				continue;
                        }
                        else if (!is_perm_in_scope(id, policydbp->p_class_val_to_name[i])) {
				if (!suppress) {
                                        yyerror2("permission %s of class %s is not within scope",
                                                 id, policydbp->p_class_val_to_name[i]);
                                }
				continue;
			} else {
                                cur_perms->data |= 1U << (perdatum->value - 1);
			}
next:
                        cur_perms = cur_perms->next;
		}

		free(id);
	}
	
	ebitmap_destroy(&tclasses);

        avrule->perms = perms;
        *rule = avrule;

out:
	return ret;

}

static avrule_t *define_cond_te_avtab(int which)
{
	char *id;
	avrule_t *avrule;
	int i;

	if (pass == 1) {
		for (i = 0; i < 4; i++) {
			while ((id = queue_remove(id_queue))) 
				free(id);
		}
		return (avrule_t *) 1; /* any non-NULL value */
	}
	
	if (define_te_avtab_helper(which, &avrule))
		return COND_ERR;
		
	return avrule;
}

static int define_te_avtab(int which)
{
	char *id;
	avrule_t *avrule;
	int i;

	if (pass == 1) {
		for (i = 0; i < 4; i++) {
			while ((id = queue_remove(id_queue))) 
				free(id);
		}
		return 0;
	}
	
	if (define_te_avtab_helper(which, &avrule))
		return -1;

        /* append this avrule to the end of the current rules list */
        append_avrule(avrule);
	return 0;
}

static int define_role_types(void)
{
	role_datum_t *role;
	char *id;
	int add = 1;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

        if ((role = declare_role()) == NULL) {
                return -1;
        }
	while ((id = queue_remove(id_queue))) {
                if (set_types(&role->types, id, &add, 0))
                        return -1;
	}


	return 0;
}


static role_datum_t *
 merge_roles_dom(role_datum_t * r1, role_datum_t * r2)
{
	role_datum_t *new;

	if (pass == 1) {
		return (role_datum_t *)1; /* any non-NULL value */
	}

	new = malloc(sizeof(role_datum_t));
	if (!new) {
		yyerror("out of memory");
		return NULL;
	}
	memset(new, 0, sizeof(role_datum_t));
	new->value = 0;		/* temporary role */
	if (ebitmap_or(&new->dominates, &r1->dominates, &r2->dominates)) {
		yyerror("out of memory");
		return NULL;
	}
	if (ebitmap_or(&new->types.types, &r1->types.types, &r2->types.types)) {
		yyerror("out of memory");
		return NULL;
	}
	if (!r1->value) {
		/* free intermediate result */
		type_set_destroy(&r1->types);
		ebitmap_destroy(&r1->dominates);
		free(r1);
	}
	if (!r2->value) {
		/* free intermediate result */
		yyerror("right hand role is temporary?");
		type_set_destroy(&r2->types);
		ebitmap_destroy(&r2->dominates);
		free(r2);
	}
	return new;
}

/* This function eliminates the ordering dependency of role dominance rule */
static int dominate_role_recheck(hashtab_key_t key, hashtab_datum_t datum, void *arg)
{
	role_datum_t *rdp = (role_datum_t *) arg;
	role_datum_t *rdatum = (role_datum_t *) datum;
	ebitmap_node_t *node;
	int i;

	/* Don't bother to process against self role */
	if (rdatum->value == rdp->value)
		return 0;

	/* If a dominating role found */
	if (ebitmap_get_bit(&(rdatum->dominates), rdp->value - 1))
	{
		ebitmap_t types;
		ebitmap_init(&types);
		if (type_set_expand(&rdp->types, &types, policydbp, 1)) {
			ebitmap_destroy(&types);
			return -1;
		}
		/* raise types and dominates from dominated role */
		ebitmap_for_each_bit(&rdp->dominates, node, i) {
			if (ebitmap_node_get_bit(node, i))
				if (ebitmap_set_bit(&rdatum->dominates, i, TRUE)) 
					goto oom;
		}
		ebitmap_for_each_bit(&types, node, i) {
			if (ebitmap_node_get_bit(node, i))
				if (ebitmap_set_bit(&rdatum->types.types, i, TRUE))
					goto oom;
		}		
		ebitmap_destroy(&types);
	}

	/* go through all the roles */
	return 0;
oom:
	yyerror("Out of memory");
	return -1;
}

static role_datum_t *
 define_role_dom(role_datum_t * r)
{
	role_datum_t *role;
	char *role_id;
	ebitmap_node_t *node;
	unsigned int i;
	int ret;

	if (pass == 1) {
		role_id = queue_remove(id_queue);
		free(role_id);
		return (role_datum_t *)1; /* any non-NULL value */
	}

	role_id = queue_remove(id_queue);
        if (!is_id_in_scope(SYM_ROLES, role_id)) {
                yyerror2("role %s is not within scope", role_id);
                free(role_id);
                return NULL;
        }
	role = (role_datum_t *) hashtab_search(policydbp->p_roles.table,
					       role_id);
	if (!role) {
		role = (role_datum_t *) malloc(sizeof(role_datum_t));
		if (!role) {
			yyerror("out of memory");
			free(role_id);
			return NULL;
		}
		memset(role, 0, sizeof(role_datum_t));
		if (ebitmap_set_bit(&role->dominates, role->value-1, TRUE)) {
                        yyerror("Out of memory!");
                        goto cleanup;
		}
		ret = declare_symbol(SYM_ROLES, (hashtab_key_t) role_id, (hashtab_datum_t) role, &role->value, &role->value);
                switch(ret) {
                case -3: {
                        yyerror("Out of memory!");
                        goto cleanup;
                }
                case -2: {
                        yyerror2("duplicate declaration of role %s", role_id);
                        goto cleanup;
                }
                case -1: {
                        yyerror("could not declare role here");
                        goto cleanup;
                }
                case 0:
                case 1: {
                        break;
                }
                default: {
                        assert(0);  /* should never get here */
                }
                }
	}
	if (r) {
		ebitmap_t types;
		ebitmap_init(&types);
		ebitmap_for_each_bit(&r->dominates, node, i) {
			if (ebitmap_node_get_bit(node, i))
				if (ebitmap_set_bit(&role->dominates, i, TRUE))
					goto oom;
		}
		if (type_set_expand(&r->types, &types, policydbp, 1)) {
			ebitmap_destroy(&types);
			return NULL;
		}
		ebitmap_for_each_bit(&types, node, i) {
			if (ebitmap_node_get_bit(node, i))
				if (ebitmap_set_bit(&role->types.types, i, TRUE))
					goto oom;
		}
		ebitmap_destroy(&types);
		if (!r->value) {
			/* free intermediate result */
			type_set_destroy(&r->types);
			ebitmap_destroy(&r->dominates);
			free(r);
		}
		/*
		 * Now go through all the roles and escalate this role's
		 * dominates and types if a role dominates this role.
		 */
		hashtab_map(policydbp->p_roles.table,
						dominate_role_recheck, role);
	}
	return role;
 cleanup:
	free(role_id);
        role_datum_destroy(role);
        free(role);
        return NULL;
oom:
	yyerror("Out of memory");
	goto cleanup;
}

static int role_val_to_name_helper(hashtab_key_t key, hashtab_datum_t datum, void *p)
{
	struct val_to_name *v = p;
	role_datum_t *roldatum;

	roldatum = (role_datum_t *) datum;

	if (v->val == roldatum->value) {
		v->name = key;
		return 1;
	}

	return 0;
}


static char *role_val_to_name(unsigned int val) 
{
	struct val_to_name v;
	int rc;

	v.val = val;
	rc = hashtab_map(policydbp->p_roles.table, 
			 role_val_to_name_helper, &v);
	if (rc)
		return v.name;
	return NULL;
}

static int set_roles(role_set_t *set,
		     char *id)
{
	role_datum_t *r;

	if (strcmp(id, "*") == 0) {
		free(id);
		yyerror("* is not allowed for role sets");
		return -1;
	}

	if (strcmp(id, "~") == 0) {
		free(id);
		yyerror("~ is not allowed for role sets");
		return -1;
	}
        if (!is_id_in_scope(SYM_ROLES, id)) {
                yyerror2("role %s is not within scope", id);
                free(id);
                return -1;
        }
	r = hashtab_search(policydbp->p_roles.table, id);
	if (!r) {
		yyerror2("unknown role %s", id);
		free(id);
		return -1;
	}

        if (ebitmap_set_bit(&set->roles, r->value - 1, TRUE)) {
		yyerror("out of memory");
		free(id);
		return -1;
	}
	free(id);
	return 0;
}


static int define_role_trans(void)
{
	char *id;
	role_datum_t *role;
	role_set_t roles;
	type_set_t types;
	ebitmap_t e_types, e_roles;
	ebitmap_node_t *tnode, *rnode;
	struct role_trans *tr = NULL;
	struct role_trans_rule *rule = NULL;
	unsigned int i, j;
	int add = 1;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		id = queue_remove(id_queue);
		free(id);
		return 0;
	}

	role_set_init(&roles);
	ebitmap_init(&e_roles);
	type_set_init(&types);
	ebitmap_init(&e_types);

	while ((id = queue_remove(id_queue))) {
		if (set_roles(&roles, id))
			return -1;
	}
        add = 1;
	while ((id = queue_remove(id_queue))) {
		if (set_types(&types, id, &add, 0))
			return -1;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no new role in transition definition?");
		goto bad;
	}
        if (!is_id_in_scope(SYM_ROLES, id)) {
                yyerror2("role %s is not within scope", id);
                free(id);
                goto bad;
        }
	role = hashtab_search(policydbp->p_roles.table, id);
	if (!role) {
		sprintf(errormsg, "unknown role %s used in transition definition", id);
		yyerror(errormsg);
		goto bad;
	}

	/* This ebitmap business is just to ensure that there are not conflicting role_trans rules */
	if (role_set_expand(&roles, &e_roles, policydbp))
		goto bad;
		
	if (type_set_expand(&types, &e_types, policydbp, 1))
		goto bad;

	ebitmap_for_each_bit(&e_roles, rnode, i) {
		if (!ebitmap_node_get_bit(rnode, i)) 
			continue;
		ebitmap_for_each_bit(&e_types, tnode, j) {
			if (!ebitmap_node_get_bit(tnode, j))
				continue;

			for (tr = policydbp->role_tr; tr; tr = tr->next) {
				if (tr->role == (i+1) && tr->type == (j+1)) {
					sprintf(errormsg, "duplicate role transition for (%s,%s)",
						role_val_to_name(i + 1), policydbp->p_type_val_to_name[j]);
					yyerror(errormsg);
					goto bad;
				}
			}

			tr = malloc(sizeof(struct role_trans));
			if (!tr) {
				yyerror("out of memory");
				return -1;
			}
			memset(tr, 0, sizeof(struct role_trans));
			tr->role = i+1;
			tr->type = j+1;
			tr->new_role = role->value;
			tr->next = policydbp->role_tr;
			policydbp->role_tr = tr;
		}
	}
	/* Now add the real rule */
	rule = malloc(sizeof(struct role_trans_rule));
	if (!rule) {
		yyerror("out of memory");
		return -1;
	}
	memset(rule, 0, sizeof(struct role_trans_rule));
	rule->roles = roles;
	rule->types = types;
	rule->new_role = role->value;

        append_role_trans(rule);

	ebitmap_destroy(&e_roles);
	ebitmap_destroy(&e_types);

	return 0;

 bad:
	return -1;
}


static int define_role_allow(void)
{
	char *id;
	struct role_allow_rule *ra = 0;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	ra = malloc(sizeof(role_allow_rule_t));
	if (!ra) {
		yyerror("out of memory");
		return -1;
	}
	role_allow_rule_init(ra);
	
	while ((id = queue_remove(id_queue))) {
		if (set_roles(&ra->roles, id))
			return -1;
	}


	while ((id = queue_remove(id_queue))) {
		if (set_roles(&ra->new_roles, id))
			return -1;
	}

        append_role_allow(ra);
	return 0;
}

static constraint_expr_t *constraint_expr_clone(constraint_expr_t *expr)
{
	constraint_expr_t *h = NULL, *l = NULL, *e, *newe;
	for (e = expr; e; e = e->next) {
		newe = malloc(sizeof(*newe));
		if (!newe)
			goto oom;
		if (constraint_expr_init(newe) == -1) {
			free(newe);
			goto oom;
		}
		if (l) 
			l->next = newe;
		else
			h = newe;
		l = newe;
		newe->expr_type = e->expr_type;
		newe->attr = e->attr;
		newe->op = e->op;
		if (newe->expr_type == CEXPR_NAMES) {
			if (newe->attr & CEXPR_TYPE) {
				if (type_set_cpy(newe->type_names, e->type_names))
					goto oom;
			} else {
				if (ebitmap_cpy(&newe->names, &e->names))
					goto oom;
			}
		}
	}

	return h;
oom:
	e = h;
	while (e) {
		l = e;
		e = e->next;
		constraint_expr_destroy(l);
	}
	return NULL;
}


static int define_constraint(constraint_expr_t * expr)
{
	struct constraint_node *node;
	char *id;
	class_datum_t *cladatum;
	perm_datum_t *perdatum;
	ebitmap_t classmap;
	ebitmap_node_t *enode;
	constraint_expr_t *e;
	unsigned int i;
	int depth;
	unsigned char useexpr = 1;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	depth = -1;
	for (e = expr; e; e = e->next) {
		switch (e->expr_type) {
		case CEXPR_NOT:
			if (depth < 0) {
				yyerror("illegal constraint expression");
				return -1;
			}
			break;
		case CEXPR_AND:
		case CEXPR_OR:
			if (depth < 1) {
				yyerror("illegal constraint expression");
				return -1;
			}
			depth--;
			break;
		case CEXPR_ATTR:
		case CEXPR_NAMES:
			if (e->attr & CEXPR_XTARGET) {
				yyerror("illegal constraint expression");
				return -1; /* only for validatetrans rules */
			}
			if (depth == (CEXPR_MAXDEPTH-1)) {
				yyerror("constraint expression is too deep");
				return -1;
			}
			depth++;
			break;
		default:
			yyerror("illegal constraint expression");
			return -1;
		}
	}
	if (depth != 0) {
		yyerror("illegal constraint expression");
		return -1;
	}

	ebitmap_init(&classmap);
	while ((id = queue_remove(id_queue))) {
                if (!is_id_in_scope(SYM_CLASSES, id)) {
                        yyerror2("class %s is not within scope", id);
                        free(id);
                        return -1;
                }
		cladatum = (class_datum_t *) hashtab_search(policydbp->p_classes.table,
						     (hashtab_key_t) id);
		if (!cladatum) {
			sprintf(errormsg, "class %s is not defined", id);
			ebitmap_destroy(&classmap);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		if (ebitmap_set_bit(&classmap, cladatum->value - 1, TRUE)) {
			yyerror("out of memory");
			ebitmap_destroy(&classmap);
			free(id);
			return -1;
		}
		node = malloc(sizeof(struct constraint_node));
		if (!node) {
			yyerror("out of memory");
			return -1;
		}
		memset(node, 0, sizeof(constraint_node_t));
		if (useexpr) {
			node->expr = expr;
			useexpr = 0;
		} else {
			node->expr = constraint_expr_clone(expr);
		}
		if (!node->expr) {
			yyerror("out of memory");
			return -1;
		}
		node->permissions = 0;

		node->next = cladatum->constraints;
		cladatum->constraints = node;

		free(id);
	}

	while ((id = queue_remove(id_queue))) {
		ebitmap_for_each_bit(&classmap, enode, i) {
			if (ebitmap_node_get_bit(enode, i)) {
				cladatum = policydbp->class_val_to_struct[i];
				node = cladatum->constraints;

				perdatum = (perm_datum_t *) hashtab_search(cladatum->permissions.table,
						     (hashtab_key_t) id);
				if (!perdatum) {
					if (cladatum->comdatum) {
						perdatum = (perm_datum_t *) hashtab_search(cladatum->comdatum->permissions.table,
						     (hashtab_key_t) id);
					}
					if (!perdatum) {
						sprintf(errormsg, "permission %s is not defined", id);
						yyerror(errormsg);
						free(id);
						ebitmap_destroy(&classmap);
						return -1;
					}
				}
				node->permissions |= (1 << (perdatum->value - 1));
			}
		}
		free(id);
	}

	ebitmap_destroy(&classmap);

	return 0;
}

static int define_validatetrans(constraint_expr_t *expr)
{
	struct constraint_node *node;
	char *id;
	class_datum_t *cladatum;
	ebitmap_t classmap;
	constraint_expr_t *e;
	int depth;
	unsigned char useexpr = 1;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	depth = -1;
	for (e = expr; e; e = e->next) {
		switch (e->expr_type) {
		case CEXPR_NOT:
			if (depth < 0) {
				yyerror("illegal validatetrans expression");
				return -1;
			}
			break;
		case CEXPR_AND:
		case CEXPR_OR:
			if (depth < 1) {
				yyerror("illegal validatetrans expression");
				return -1;
			}
			depth--;
			break;
		case CEXPR_ATTR:
		case CEXPR_NAMES:
			if (depth == (CEXPR_MAXDEPTH - 1)) {
				yyerror("validatetrans expression is too deep");
				return -1;
			}
			depth++;
			break;
		default:
			yyerror("illegal validatetrans expression");
			return -1;
		}
	}
	if (depth != 0) {
		yyerror("illegal validatetrans expression");
		return -1;
	}

	ebitmap_init(&classmap);
	while ((id = queue_remove(id_queue))) {
                if (!is_id_in_scope(SYM_CLASSES, id)) {
                        yyerror2("class %s is not within scope", id);
                        free(id);
                        return -1;
                }
		cladatum = (class_datum_t *)hashtab_search(policydbp->p_classes.table, (hashtab_key_t)id);
		if (!cladatum) {
			sprintf(errormsg, "class %s is not defined", id);
			ebitmap_destroy(&classmap);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		if (ebitmap_set_bit(&classmap, (cladatum->value - 1), TRUE)) {
			yyerror("out of memory");
			ebitmap_destroy(&classmap);
			free(id);
			return -1;
		}

		node = malloc(sizeof(struct constraint_node));
		if (!node) {
			yyerror("out of memory");
			return -1;
		}
		memset(node, 0, sizeof(constraint_node_t));
		if (useexpr) {
			node->expr = expr;
			useexpr = 0;
		} else {
			node->expr = constraint_expr_clone(expr);
		}
		node->permissions = 0;

		node->next = cladatum->validatetrans;
		cladatum->validatetrans = node;

		free(id);
	}

	ebitmap_destroy(&classmap);

	return 0;
}


static uintptr_t
 define_cexpr(uint32_t expr_type, uintptr_t arg1, uintptr_t arg2)
{
	struct constraint_expr *expr, *e1 = NULL, *e2;
	user_datum_t *user;
	role_datum_t *role;
	ebitmap_t negset;
	char *id;
	uint32_t val;
        int add = 1;

	if (pass == 1) {
		if (expr_type == CEXPR_NAMES) {
			while ((id = queue_remove(id_queue))) 
				free(id);
		}
		return 1; /* any non-NULL value */
	}

	if ((expr = malloc(sizeof(*expr))) == NULL ||
            constraint_expr_init(expr) == - 1) {
		yyerror("out of memory");
		free(expr);
		return 0;
	}
	expr->expr_type = expr_type;

	switch (expr_type) {
	case CEXPR_NOT:
		e1 = NULL;
		e2 = (struct constraint_expr *) arg1;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal constraint expression");
                        constraint_expr_destroy(expr);
			return 0;
		}
		e1->next = expr;
		return arg1;
	case CEXPR_AND:
	case CEXPR_OR:
		e1 = NULL;
		e2 = (struct constraint_expr *) arg1;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal constraint expression");
                        constraint_expr_destroy(expr);
			return 0;
		}
		e1->next = (struct constraint_expr *) arg2;

		e1 = NULL;
		e2 = (struct constraint_expr *) arg2;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal constraint expression");
                        constraint_expr_destroy(expr);
			return 0;
		}
		e1->next = expr;
		return arg1;
	case CEXPR_ATTR:
		expr->attr = arg1;
		expr->op = arg2;
		return (uintptr_t)expr;
	case CEXPR_NAMES:
                add = 1;
		expr->attr = arg1;
		expr->op = arg2;
		ebitmap_init(&negset);
		while ((id = (char *) queue_remove(id_queue))) {
			if (expr->attr & CEXPR_USER) {
                                if (!is_id_in_scope(SYM_USERS, id)) {
                                        yyerror2("user %s is not within scope", id);
                                        constraint_expr_destroy(expr);
                                        return 0;
                                }
				user = (user_datum_t *) hashtab_search(policydbp->p_users.table,
								       (hashtab_key_t) id);
				if (!user) {
					sprintf(errormsg, "unknown user %s", id);
					yyerror(errormsg);
                                        constraint_expr_destroy(expr);
					return 0;
				}
				val = user->value;
			} else if (expr->attr & CEXPR_ROLE) {
                                if (!is_id_in_scope(SYM_ROLES, id)) {
                                        yyerror2("role %s is not within scope", id);
                                        constraint_expr_destroy(expr);
                                        return 0;
                                }
				role = (role_datum_t *) hashtab_search(policydbp->p_roles.table,
								       (hashtab_key_t) id);
				if (!role) {
					sprintf(errormsg, "unknown role %s", id);
					yyerror(errormsg);
                                        constraint_expr_destroy(expr);
					return 0;
				}
				val = role->value;
			} else if (expr->attr & CEXPR_TYPE) {
                                if (set_types(expr->type_names, id, &add, 0)) {
                                        constraint_expr_destroy(expr);
					return 0;
				}
				continue;
			} else {
				yyerror("invalid constraint expression");
                                constraint_expr_destroy(expr);
				return 0;
			}
			if (ebitmap_set_bit(&expr->names, val - 1, TRUE)) {
				yyerror("out of memory");
				ebitmap_destroy(&expr->names);
                                constraint_expr_destroy(expr);
				return 0;
			}
			free(id);
		}
		ebitmap_destroy(&negset);
		return (uintptr_t)expr;
	default:
		yyerror("invalid constraint expression");
                constraint_expr_destroy(expr);
		return 0;
	}

	yyerror("invalid constraint expression");
	free(expr);
	return 0;
}

static int define_conditional(cond_expr_t *expr, avrule_t *t, avrule_t *f )
{
	cond_expr_t *e;
	int depth, retval;
        cond_node_t cn, *cn_old;
        avrule_t *tmp, *last_tmp;

	/* expression cannot be NULL */
	if ( !expr) {
		yyerror("illegal conditional expression");
		return -1;
	}
	if (!t) {
		if (!f) {
			/* empty is fine, destroy expression and return */
			cond_expr_destroy(expr);
			return 0;
		}
		/* Invert */
		t = f;
		f = 0;
		expr = define_cond_expr(COND_NOT, expr, 0);
		if (!expr) {
			yyerror("unable to invert");
			return -1;
		}
	}

	/* verify expression */
	depth = -1;
	for (e = expr; e; e = e->next) {
		switch (e->expr_type) {
		case COND_NOT:
			if (depth < 0) {
				yyerror("illegal conditional expression; Bad NOT");
				return -1;
			}
			break;
		case COND_AND:
		case COND_OR:
		case COND_XOR:
		case COND_EQ:
		case COND_NEQ:
			if (depth < 1) {
				yyerror("illegal conditional expression; Bad binary op");
				return -1;
			}
			depth--;
			break;
		case COND_BOOL:
			if (depth == (COND_EXPR_MAXDEPTH-1)) {
				yyerror("conditional expression is like totally too deep");
				return -1;
			}
			depth++;
			break;
		default:
			yyerror("illegal conditional expression");
			return -1;
		}
	}
	if (depth != 0) {
		yyerror("illegal conditional expression");
		return -1;
	}

        /*  use tmp conditional node to partially build new node */
        memset(&cn, 0, sizeof(cn));
        cn.expr = expr;
        cn.avtrue_list = t;
        cn.avfalse_list = f;

	/* normalize/precompute expression */
	if (cond_normalize_expr(policydbp, &cn) < 0) {
		yyerror("problem normalizing conditional expression");
		return -1;
	}

        /* get the existing conditional node, or create a new one*/
        cn_old = get_current_cond_list(&cn);
        if (!cn_old) {
                return -1;
        }

        /* verify te rules -- both true and false branches of conditional */
	tmp = cn.avtrue_list;
        last_tmp = NULL;
	while (tmp) {
		if (!tmp->specified & AVRULE_TRANSITION)
			continue;
		retval = insert_check_type_rule(tmp,
                                                &policydbp->te_cond_avtab,
                                                &cn_old->true_list, &cn_old->false_list);
                switch (retval) {
                case 1: {
                        last_tmp = tmp;
                        tmp = tmp->next;
                        break;
                }
                case 0: {
                        /* rule conflicted, so remove it from consideration */
                        if (last_tmp == NULL) {
                                cn.avtrue_list = cn.avtrue_list->next;
                                avrule_destroy(tmp);
				free(tmp);
                                tmp = cn.avtrue_list;
                        }
                        else {
                                last_tmp->next = tmp->next;
                                avrule_destroy(tmp);
				free(tmp);
                                tmp = last_tmp->next;
                        }
                        break;
                }
                case -1: {
                        return -1;
                }
                default: {
                        assert(0);  /* should never get here */
                }
                }
	}
	
	tmp = cn.avfalse_list;
        last_tmp = NULL;
	while (tmp) {
		if (!tmp->specified & AVRULE_TRANSITION)
			continue;
		retval = insert_check_type_rule(tmp,
                                                &policydbp->te_cond_avtab,
                                                &cn_old->false_list, &cn_old->true_list);
                switch (retval) {
                case 1: {
                        last_tmp = tmp;
                        tmp = tmp->next;
                        break;
                }
                case 0: {
                        /* rule conflicted, so remove it from consideration  */
                        if (last_tmp == NULL) {
                                cn.avfalse_list = cn.avfalse_list->next;
                                avrule_destroy(tmp);
				free(tmp);
                                tmp = cn.avfalse_list;
                        }
                        else {
                                last_tmp->next = tmp->next;
                                avrule_destroy(tmp);
				free(tmp);
                                tmp = last_tmp->next;
                        }
                        break;
                }
                case -1: {
                        return -1;
                }
                default: {
                        assert(0);  /* should never get here */
                }
                }
	}

        append_cond_list(&cn);
        
        /* note that there is no check here for duplicate rules, nor
         * check that rule already exists in base -- that will be
         * handled during conditional expansion, in expand.c */
        
	cn.avtrue_list = NULL;
	cn.avfalse_list = NULL;
	cond_node_destroy(&cn);

	return 0;
}

static cond_expr_t *
 define_cond_expr(uint32_t expr_type, void* arg1, void* arg2)
{
	struct cond_expr *expr, *e1 = NULL, *e2;
	cond_bool_datum_t *bool_var;
	char *id;

	/* expressions are handled in the second pass */
	if (pass == 1) {
		if (expr_type == COND_BOOL) {
			while ((id = queue_remove(id_queue))) {
				free(id);
			}
		}
		return (cond_expr_t *)1; /* any non-NULL value */
	}

	/* create a new expression struct */
	expr = malloc(sizeof(struct cond_expr));
	if (!expr) {
		yyerror("out of memory");
		return NULL;
	}
	memset(expr, 0, sizeof(cond_expr_t));
	expr->expr_type = expr_type;

	/* create the type asked for */
	switch (expr_type) {
	case COND_NOT:
		e1 = NULL;
		e2 = (struct cond_expr *) arg1;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal conditional NOT expression");
			free(expr);
			return NULL;
		}
		e1->next = expr;
		return (struct cond_expr *) arg1;
	case COND_AND:
	case COND_OR:
	case COND_XOR:
	case COND_EQ:
	case COND_NEQ:
		e1 = NULL;
		e2 = (struct cond_expr *) arg1;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal left side of conditional binary op expression");
			free(expr);
			return NULL;
		}
		e1->next = (struct cond_expr *) arg2;

		e1 = NULL;
		e2 = (struct cond_expr *) arg2;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal right side of conditional binary op expression");
			free(expr);
			return NULL ;
		}
		e1->next = expr;
		return (struct cond_expr *) arg1;
	case COND_BOOL:
		id = (char *) queue_remove(id_queue) ;
		if (!id) {
			yyerror("bad conditional; expected boolean id");
			free(id);
			free(expr);
			return NULL;
		}
                if (!is_id_in_scope(SYM_BOOLS, id)) {
                        yyerror2("boolean %s is not within scope", id);
                        free(id);
                        free(expr);
                        return NULL;
                }
		bool_var = (cond_bool_datum_t *) hashtab_search(policydbp->p_bools.table,
								(hashtab_key_t) id);
		if (!bool_var) {
			sprintf(errormsg, "unknown boolean %s in conditional expression", id);
			yyerror(errormsg);
			free(expr);
			free(id);
			return NULL ;
		}
		expr->bool = bool_var->value;
		free(id);
		return expr;
	default:
		yyerror("illegal conditional expression");
		return NULL;
	}
}


static int set_user_roles(role_set_t *set,
			  char *id)
{
	role_datum_t *r;
	unsigned int i;
	ebitmap_node_t *node;

	if (strcmp(id, "*") == 0) {
		free(id);
		yyerror("* is not allowed in user declarations");
		return -1;
	}

	if (strcmp(id, "~") == 0) {
		free(id);
		yyerror("~ is not allowed in user declarations");
		return -1;
	}

        if (!is_id_in_scope(SYM_ROLES, id)) {
                yyerror2("role %s is not within scope", id);
                free(id);
                return -1;
        }
	r = hashtab_search(policydbp->p_roles.table, id);
	if (!r) {
		sprintf(errormsg, "unknown role %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}

	/* set the role and every role it dominates */
	ebitmap_for_each_bit(&r->dominates, node, i) {
		if (ebitmap_node_get_bit(node, i))
			if (ebitmap_set_bit(&set->roles, i, TRUE))
				goto oom;
	}
	free(id);
	return 0;
oom:
	yyerror("out of memory");
	return -1;
}


static int
parse_categories(char *id, level_datum_t *levdatum, ebitmap_t *cats)
{
	cat_datum_t *cdatum;
	int range_start, range_end, i;

	if (id_has_dot(id)) {
		char *id_start = id;
		char *id_end = strchr(id, '.');

		*(id_end++) = '\0';

		cdatum = (cat_datum_t *)hashtab_search(policydbp->p_cats.table,
		                                       (hashtab_key_t)id_start);
		if (!cdatum) {
			sprintf(errormsg, "unknown category %s", id_start);
			yyerror(errormsg);
			return -1;
		}
		range_start = cdatum->value - 1;
		cdatum = (cat_datum_t *)hashtab_search(policydbp->p_cats.table,
		                                       (hashtab_key_t)id_end);
		if (!cdatum) {
			sprintf(errormsg, "unknown category %s", id_end);
			yyerror(errormsg);
			return -1;
		}
		range_end = cdatum->value - 1;

		if (range_end < range_start) {
			sprintf(errormsg, "category range is invalid");
			yyerror(errormsg);
			return -1;
		}
	} else {
		cdatum = (cat_datum_t *)hashtab_search(policydbp->p_cats.table,
		                                       (hashtab_key_t)id);
		if (!cdatum) {
			sprintf(errormsg, "unknown category %s", id);
			yyerror(errormsg);
			return -1;
		}
		range_start = range_end = cdatum->value - 1;
	}

	for (i = range_start; i <= range_end; i++) {
		if (!ebitmap_get_bit(&levdatum->level->cat, i)) {
			uint32_t level_value = levdatum->level->sens - 1;
			policydb_index_others(NULL, policydbp, 0);
			sprintf(errormsg, "category %s can not be associated "
			        "with level %s",
			        policydbp->p_cat_val_to_name[i],
			        policydbp->p_sens_val_to_name[level_value]);
			yyerror(errormsg);
			return -1;
		}
		if (ebitmap_set_bit(cats, i, TRUE)) {
			yyerror("out of memory");
			return -1;
		}
	}

	return 0;
}


static int define_user(void)
{
	char *id;
	user_datum_t *usrdatum;
	level_datum_t *levdatum;
	int l;

	if (policydbp->policy_type == POLICY_MOD && mlspol) {
		yyerror("Users cannot be declared in MLS modules");
		return -1;
	}

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		if (mlspol) {
			while ((id = queue_remove(id_queue))) 
				free(id);
			id = queue_remove(id_queue); free(id);
			for (l = 0; l < 2; l++) {
				while ((id = queue_remove(id_queue))) { 
					free(id);
				}
				id = queue_remove(id_queue);
				if (!id)
					break;
				free(id);
			}
		}
		return 0;
	}

        if ((usrdatum = declare_user()) == NULL) {
                return -1;
        }

	while ((id = queue_remove(id_queue))) {
		if (set_user_roles(&usrdatum->roles, id))
			continue;
	}

	if (mlspol) {
		id = queue_remove(id_queue);
		if (!id) {
			yyerror("no default level specified for user");
			return -1;
		}

		levdatum = (level_datum_t *)
				hashtab_search(policydbp->p_levels.table,
						(hashtab_key_t) id);
		if (!levdatum) {
			sprintf(errormsg, "unknown sensitivity %s used in user"
					" level definition", id);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		free(id);

		usrdatum->dfltlevel.sens = levdatum->level->sens;
		ebitmap_init(&usrdatum->dfltlevel.cat);

		while ((id = queue_remove(id_queue))) {
			if (parse_categories(id, levdatum,
			                     &usrdatum->dfltlevel.cat)) {
				free(id);
				return -1;
			}
			free(id);
		}

		id = queue_remove(id_queue);

		for (l = 0; l < 2; l++) {
			levdatum = (level_datum_t *)
				hashtab_search(policydbp->p_levels.table,
						     (hashtab_key_t) id);
			if (!levdatum) {
				sprintf(errormsg, "unknown sensitivity %s used in user range definition", id);
				yyerror(errormsg);
				free(id);
				return -1;
			}
			free(id);
			usrdatum->range.level[l].sens = levdatum->level->sens;
			ebitmap_init(&usrdatum->range.level[l].cat);

			while ((id = queue_remove(id_queue))) {
				if (parse_categories(id, levdatum,
				              &usrdatum->range.level[l].cat)) {
					free(id);
					return -1;
				}
				free(id);
			}

			id = queue_remove(id_queue);
			if (!id)
				break;
		}

		if (l == 0) {
			usrdatum->range.level[1].sens =
						usrdatum->range.level[0].sens;
			if (ebitmap_cpy(&usrdatum->range.level[1].cat,
			                &usrdatum->range.level[0].cat)) {
				yyerror("out of memory");
				goto out;
			}
		}
		if (!mls_level_dom(&usrdatum->range.level[1],
		                   &usrdatum->range.level[0])) {
			yyerror("high level does not dominate low level");
			goto out;
		}
		if (!mls_level_between(&usrdatum->dfltlevel,
		                       &usrdatum->range.level[0],
		                       &usrdatum->range.level[1])) {
			yyerror("default level not within user range");
			goto out;
		}
	}
	return 0;

out:
	ebitmap_destroy(&usrdatum->dfltlevel.cat);
	ebitmap_destroy(&usrdatum->range.level[0].cat);
	ebitmap_destroy(&usrdatum->range.level[1].cat);
	return -1;
}


static int parse_security_context(context_struct_t * c)
{
	char *id;
	role_datum_t *role;
	type_datum_t *typdatum;
	user_datum_t *usrdatum;
	level_datum_t *levdatum;
	int l;

	if (pass == 1) {
		id = queue_remove(id_queue); free(id); /* user  */
		id = queue_remove(id_queue); free(id); /* role  */
		id = queue_remove(id_queue); free(id); /* type  */
		if (mlspol) {
			id = queue_remove(id_queue); free(id); 
			for (l = 0; l < 2; l++) {
				while ((id = queue_remove(id_queue))) {
					free(id);
				}
				id = queue_remove(id_queue);
				if (!id)
					break;
				free(id); 
			}
		}
		return 0;
	}

	context_init(c);

	/* extract the user */
	id = queue_remove(id_queue);
	if (!id) {
		yyerror("no effective user?");
		goto bad;
	}
        if (!is_id_in_scope(SYM_USERS, id)) {
                yyerror2("user %s is not within scope", id);
                free(id);
                goto bad;
        }
	usrdatum = (user_datum_t *) hashtab_search(policydbp->p_users.table,
						   (hashtab_key_t) id);
	if (!usrdatum) {
		sprintf(errormsg, "user %s is not defined", id);
		yyerror(errormsg);
		free(id);
		goto bad;
	}
	c->user = usrdatum->value;

	/* no need to keep the user name */
	free(id);

	/* extract the role */
	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no role name for sid context definition?");
		return -1;
	}
        if (!is_id_in_scope(SYM_ROLES, id)) {
                yyerror2("role %s is not within scope", id);
                free(id);
                return -1;
        }
	role = (role_datum_t *) hashtab_search(policydbp->p_roles.table,
					       (hashtab_key_t) id);
	if (!role) {
		sprintf(errormsg, "role %s is not defined", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	c->role = role->value;

	/* no need to keep the role name */
	free(id);


	/* extract the type */
	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no type name for sid context definition?");
		return -1;
	}
        if (!is_id_in_scope(SYM_TYPES, id)) {
                yyerror2("type %s is not within scope", id);
                free(id);
                return -1;
        }
	typdatum = (type_datum_t *) hashtab_search(policydbp->p_types.table,
						   (hashtab_key_t) id);
	if (!typdatum || typdatum->isattr) {
		sprintf(errormsg, "type %s is not defined or is an attribute", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	c->type = typdatum->value;

	/* no need to keep the type name */
	free(id);

	if (mlspol) {
		/* extract the low sensitivity */
		id = (char *) queue_head(id_queue);
		if (!id) {
			yyerror("no sensitivity name for sid context"
							" definition?");
			return -1;
		}

		id = (char *) queue_remove(id_queue);
		for (l = 0; l < 2; l++) {
			levdatum = (level_datum_t *)
				hashtab_search(policydbp->p_levels.table,
						     (hashtab_key_t) id);
			if (!levdatum) {
				sprintf(errormsg, "Sensitivity %s is not "
								"defined", id);
				yyerror(errormsg);
				free(id);
				return -1;
			}
			free(id);
			c->range.level[l].sens = levdatum->level->sens;

			/* extract low category set */
			while ((id = queue_remove(id_queue))) {
				if (parse_categories(id, levdatum,
				                     &c->range.level[l].cat)) {
					free(id);
					return -1;
				}
				free(id);
			}

			/* extract high sensitivity */
			id = (char *) queue_remove(id_queue);
			if (!id)
				break;
		}

		if (l == 0) {
			c->range.level[1].sens = c->range.level[0].sens;
			if (ebitmap_cpy(&c->range.level[1].cat,
						&c->range.level[0].cat)) {

				yyerror("out of memory");
				goto bad;
			}
		}
	}

	if (!policydb_context_isvalid(policydbp, c)) {
		yyerror("invalid security context");
		goto bad;
	}
	return 0;

      bad:
	context_destroy(c);

	return -1;
}


static int define_initial_sid_context(void)
{
	char *id;
	ocontext_t *c, *head;

	if (pass == 1) {
		id = (char *) queue_remove(id_queue); free(id);
		parse_security_context(NULL);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no sid name for SID context definition?");
		return -1;
	}
	head = policydbp->ocontexts[OCON_ISID];
	for (c = head; c; c = c->next) {
		if (!strcmp(id, c->u.name))
			break;
	}

	if (!c) {
		sprintf(errormsg, "SID %s is not defined", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	if (c->context[0].user) {
		sprintf(errormsg, "The context for SID %s is multiply defined", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	/* no need to keep the sid name */
	free(id);

	if (parse_security_context(&c->context[0]))
		return -1;

	return 0;
}

static int define_fs_context(unsigned int major, unsigned int minor)
{
	ocontext_t *newc, *c, *head;

	if (pass == 1) {
		parse_security_context(NULL);
		parse_security_context(NULL);
		return 0;
	}

	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.name = (char *) malloc(6);
	if (!newc->u.name) {
		yyerror("out of memory");
		free(newc);
		return -1;
	}
	sprintf(newc->u.name, "%02x:%02x", major, minor);

	if (parse_security_context(&newc->context[0])) {
		free(newc->u.name);
		free(newc);
		return -1;
	}
	if (parse_security_context(&newc->context[1])) {
		context_destroy(&newc->context[0]);
		free(newc->u.name);
		free(newc);
		return -1;
	}
	head = policydbp->ocontexts[OCON_FS];

	for (c = head; c; c = c->next) {
		if (!strcmp(newc->u.name, c->u.name)) {
			sprintf(errormsg, "duplicate entry for file system %s", newc->u.name);
			yyerror(errormsg);
			context_destroy(&newc->context[0]);
			context_destroy(&newc->context[1]);
			free(newc->u.name);
			free(newc);
			return -1;
		}
	}

	newc->next = head;
	policydbp->ocontexts[OCON_FS] = newc;

	return 0;
}

static int define_port_context(unsigned int low, unsigned int high)
{
	ocontext_t *newc, *c, *l, *head;
	unsigned int protocol;
	char *id;

	if (pass == 1) {
		id = (char *) queue_remove(id_queue); free(id);
		parse_security_context(NULL);
		return 0;
	}

	newc = malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	id = (char *) queue_remove(id_queue);
	if (!id) {
		free(newc);
		return -1;
	}
	if ((strcmp(id, "tcp") == 0) || (strcmp(id, "TCP") == 0)) {
		protocol = IPPROTO_TCP;
	} else if ((strcmp(id, "udp") == 0) || (strcmp(id, "UDP") == 0)) {
		protocol = IPPROTO_UDP;
	} else {
		sprintf(errormsg, "unrecognized protocol %s", id);
		yyerror(errormsg);
		free(newc);
		return -1;
	}

	newc->u.port.protocol = protocol;
	newc->u.port.low_port = low;
	newc->u.port.high_port = high;

	if (low > high) {
		sprintf(errormsg, "low port %d exceeds high port %d", low, high);
		yyerror(errormsg);
		free(newc);
		return -1;
	}

	if (parse_security_context(&newc->context[0])) {
		free(newc);
		return -1;
	}

	/* Preserve the matching order specified in the configuration. */
	head = policydbp->ocontexts[OCON_PORT];
	for (l = NULL, c = head; c; l = c, c = c->next) {
		unsigned int prot2, low2, high2;

		prot2 = c->u.port.protocol;
		low2 = c->u.port.low_port;
		high2 = c->u.port.high_port;
		if (protocol != prot2)
			continue;
		if (low == low2 && high == high2) {
			sprintf(errormsg, "duplicate portcon entry for %s %d-%d ", id, low, high);
			goto bad;
		}
		if (low2 <= low && high2 >= high) {
			sprintf(errormsg, "portcon entry for %s %d-%d hidden by earlier entry for %d-%d", id, low, high, low2, high2);
			goto bad;
		}
	}

	if (l)
		l->next = newc;
	else
		policydbp->ocontexts[OCON_PORT] = newc;

	return 0;

bad:
	yyerror(errormsg);
	free(newc);
	return -1;
}

static int define_netif_context(void)
{
	ocontext_t *newc, *c, *head;

	if (pass == 1) {
		free(queue_remove(id_queue));
		parse_security_context(NULL);
		parse_security_context(NULL);
		return 0;
	}

	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.name = (char *) queue_remove(id_queue);
	if (!newc->u.name) {
		free(newc);
		return -1;
	}
	if (parse_security_context(&newc->context[0])) {
		free(newc->u.name);
		free(newc);
		return -1;
	}
	if (parse_security_context(&newc->context[1])) {
		context_destroy(&newc->context[0]);
		free(newc->u.name);
		free(newc);
		return -1;
	}
	head = policydbp->ocontexts[OCON_NETIF];

	for (c = head; c; c = c->next) {
		if (!strcmp(newc->u.name, c->u.name)) {
			sprintf(errormsg, "duplicate entry for network interface %s", newc->u.name);
			yyerror(errormsg);
			context_destroy(&newc->context[0]);
			context_destroy(&newc->context[1]);
			free(newc->u.name);
			free(newc);
			return -1;
		}
	}

	newc->next = head;
	policydbp->ocontexts[OCON_NETIF] = newc;
	return 0;
}

static int define_ipv4_node_context(unsigned int addr, unsigned int mask)
{
	ocontext_t *newc, *c, *l, *head;

	if (pass == 1) {
		parse_security_context(NULL);
		if (mlspol)
			free(queue_remove(id_queue));
		return 0;
	}

	newc = malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.node.addr = addr;
	newc->u.node.mask = mask;

	if (parse_security_context(&newc->context[0])) {
		free(newc);
		return -1;
	}

 	/* Create order of most specific to least retaining
 	   the order specified in the configuration. */
	head = policydbp->ocontexts[OCON_NODE];
	for (l = NULL, c = head; c; l = c, c = c->next) {
 		if (newc->u.node.mask > c->u.node.mask)
 			break;
 	}

	newc->next = c;

	if (l)
		l->next = newc;
	else
		policydbp->ocontexts[OCON_NODE] = newc;

	return 0;
}

static int define_ipv6_node_context(void)
{
	char *id;
	int rc = 0;
	struct in6_addr addr, mask;
	ocontext_t *newc, *c, *l, *head;
	
	if (pass == 1) {
		free(queue_remove(id_queue));
		free(queue_remove(id_queue));
		parse_security_context(NULL);
		goto out;
	}
	
	id = queue_remove(id_queue);
	if (!id) {
		yyerror("failed to read ipv6 address");
		rc = -1;
		goto out;
	}

	rc = inet_pton(AF_INET6, id, &addr);
	free (id);
	if (rc < 1) {
		yyerror("failed to parse ipv6 address");
		if (rc == 0)
			rc = -1;
		goto out;
	}

	id = queue_remove(id_queue);
	if (!id) {
		yyerror("failed to read ipv6 address");
		rc = -1;
		goto out;
	}

	rc = inet_pton(AF_INET6, id, &mask);
	free(id);
	if (rc < 1) {
		yyerror("failed to parse ipv6 mask");
		if (rc == 0)
			rc = -1;
		goto out;
	}
	
	newc = malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		rc = -1;
		goto out;
	}

	memset(newc, 0, sizeof(ocontext_t));
	memcpy(&newc->u.node6.addr[0], &addr.s6_addr32[0], 16);
	memcpy(&newc->u.node6.mask[0], &mask.s6_addr32[0], 16);

	if (parse_security_context(&newc->context[0])) {
		free(newc);
		rc = -1;
		goto out;
	}

	/* Create order of most specific to least retaining
	   the order specified in the configuration. */
	head = policydbp->ocontexts[OCON_NODE6];
	for (l = NULL, c = head; c; l = c, c = c->next) {
		if (memcmp(&newc->u.node6.mask,&c->u.node6.mask,16) > 0)
			break;
	}

	newc->next = c;

	if (l)
		l->next = newc;
	else
		policydbp->ocontexts[OCON_NODE6] = newc;

	rc = 0;
out:
	return rc;
}

static int define_fs_use(int behavior)
{
	ocontext_t *newc, *c, *head;

	if (pass == 1) {
		free(queue_remove(id_queue));
		parse_security_context(NULL);
		return 0;
	}

	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.name = (char *) queue_remove(id_queue);
	if (!newc->u.name) {
		free(newc);
		return -1;
	}
	newc->v.behavior = behavior;
	if (parse_security_context(&newc->context[0])) {
		free(newc->u.name);
		free(newc);
		return -1;
	}

	head = policydbp->ocontexts[OCON_FSUSE];

	for (c = head; c; c = c->next) {
		if (!strcmp(newc->u.name, c->u.name)) {
			sprintf(errormsg, "duplicate fs_use entry for filesystem type %s", newc->u.name);
			yyerror(errormsg);
			context_destroy(&newc->context[0]);
			free(newc->u.name);
			free(newc);
			return -1;
		}
	}

	newc->next = head;
	policydbp->ocontexts[OCON_FSUSE] = newc;
	return 0;
}

static int define_genfs_context_helper(char *fstype, int has_type)
{
	struct genfs *genfs_p, *genfs, *newgenfs;
	ocontext_t *newc, *c, *head, *p;
	char *type = NULL;
	int len, len2;

	if (pass == 1) {
		free(fstype);
		free(queue_remove(id_queue));
		if (has_type)
			free(queue_remove(id_queue));
		parse_security_context(NULL);
		return 0;
	}

	for (genfs_p = NULL, genfs = policydbp->genfs; 
	     genfs; genfs_p = genfs, genfs = genfs->next) {
		if (strcmp(fstype, genfs->fstype) <= 0)
			break;
	}

	if (!genfs || strcmp(fstype, genfs->fstype)) {
		newgenfs = malloc(sizeof(struct genfs));
		if (!newgenfs) {
			yyerror("out of memory");
			return -1;
		}
		memset(newgenfs, 0, sizeof(struct genfs));
		newgenfs->fstype = fstype;
		newgenfs->next = genfs;
		if (genfs_p) 
			genfs_p->next = newgenfs;
		else
			policydbp->genfs = newgenfs;
		genfs = newgenfs;
	}

	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.name = (char *) queue_remove(id_queue);
	if (!newc->u.name) 
		goto fail;
	if (has_type) {
		type = (char *) queue_remove(id_queue);
		if (!type) 
			goto fail;
		if (type[1] != 0) {
			sprintf(errormsg, "invalid type %s", type);
			yyerror(errormsg);
			goto fail;
		}
		switch (type[0]) {
		case 'b':
			newc->v.sclass = SECCLASS_BLK_FILE;
			break;
		case 'c':
			newc->v.sclass = SECCLASS_CHR_FILE;
			break;
		case 'd':
			newc->v.sclass = SECCLASS_DIR;
			break;
		case 'p':
			newc->v.sclass = SECCLASS_FIFO_FILE;
			break;
		case 'l':
			newc->v.sclass = SECCLASS_LNK_FILE;
			break;
		case 's':
			newc->v.sclass = SECCLASS_SOCK_FILE;
			break;
		case '-':
			newc->v.sclass = SECCLASS_FILE;
			break;
		default:
			sprintf(errormsg, "invalid type %s", type);
			yyerror(errormsg);
			goto fail;
		}
	}
	if (parse_security_context(&newc->context[0])) 
		goto fail;

	head = genfs->head;

	for (p = NULL, c = head; c; p = c, c = c->next) {
		if (!strcmp(newc->u.name, c->u.name) && 
		    (!newc->v.sclass || !c->v.sclass || newc->v.sclass == c->v.sclass)) {
			sprintf(errormsg, "duplicate entry for genfs entry (%s, %s)", fstype, newc->u.name);
			yyerror(errormsg);
			goto fail;
		}
		len = strlen(newc->u.name);
		len2 = strlen(c->u.name);
		if (len > len2)
			break;
	}

	newc->next = c;
	if (p) 
		p->next = newc;
	else
		genfs->head = newc;
	return 0;
fail:
	if (type)
		free(type);
	context_destroy(&newc->context[0]);
	if (fstype)
		free(fstype);
	if (newc->u.name)
		free(newc->u.name);
	free(newc);
	return -1;
}

static int define_genfs_context(int has_type)
{
	return define_genfs_context_helper(queue_remove(id_queue), has_type);
}

static int define_range_trans(void)
{
	char *id;
	level_datum_t *levdatum = 0;
	mls_range_t range;
	type_set_t doms, types;
	ebitmap_node_t *snode, *tnode;
	range_trans_t *rt = 0;
	unsigned int i, j;
	int l, add = 1;

	if (!mlspol) {
		yyerror("range_transition rule in non-MLS configuration");
		return -1;
	}

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		id = queue_remove(id_queue); free(id); 
		for (l = 0; l < 2; l++) {
			while ((id = queue_remove(id_queue))) {
				free(id);
			}
			id = queue_remove(id_queue);
			if (!id)
				break;
			free(id); 
		}
		return 0;
	}

	type_set_init(&doms);
	type_set_init(&types);
        
	while ((id = queue_remove(id_queue))) {
		if (set_types(&doms, id, &add, 0))
			return -1;
	}
        add = 1;
	while ((id = queue_remove(id_queue))) {
		if (set_types(&types, id, &add, 0))
			return -1;
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no range in range_transition definition?");
		return -1;
	}
	for (l = 0; l < 2; l++) {
		levdatum = hashtab_search(policydbp->p_levels.table, id);
		if (!levdatum) {
			sprintf(errormsg, "unknown level %s used in range_transition definition", id);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		free(id);
		range.level[l].sens = levdatum->level->sens;

		ebitmap_init(&range.level[l].cat);

		while ((id = queue_remove(id_queue))) {
			if (parse_categories(id, levdatum,
			                     &range.level[l].cat)) {
				free(id);
				return -1;
			}
			free(id);
		}

		id = (char *)queue_remove(id_queue);
		if (!id)
			break;
	}
	if (l == 0) {
		range.level[1].sens = range.level[0].sens;
		if (ebitmap_cpy(&range.level[1].cat, &range.level[0].cat)) {
			yyerror("out of memory");
			return -1;
		}
	}

	if (!mls_level_dom(&range.level[1], &range.level[0])) {
		yyerror("range_transition high level does not dominate low level");
		return -1;
	}

	ebitmap_for_each_bit(&doms.types, snode, i) {
		if (!ebitmap_node_get_bit(snode, i))
			continue;
		ebitmap_for_each_bit(&types.types, tnode, j) {
			if (!ebitmap_node_get_bit(tnode, j))
				continue;

			for (rt = policydbp->range_tr; rt; rt = rt->next) {
				if (rt->dom == (i + 1) && rt->type == (j + 1)) {
					sprintf(errormsg, "duplicate range_transition defined for (%s,%s)",
					        policydbp->p_type_val_to_name[i], policydbp->p_type_val_to_name[j]);
					yyerror(errormsg);
					return -1;
				}
			}

			rt = malloc(sizeof(range_trans_t));
			if (!rt) {
				yyerror("out of memory");
				return -1;
			}
			memset(rt, 0, sizeof(range_trans_t));
			rt->dom = i + 1;
			rt->type = j + 1;
			rt->range.level[0].sens = range.level[0].sens;
			if (ebitmap_cpy(&rt->range.level[0].cat,
			               &range.level[0].cat)) {
				yyerror("out of memory");
				free(rt);
				return -1;
			}
			rt->range.level[1].sens = range.level[1].sens;
			if (ebitmap_cpy(&rt->range.level[1].cat,
			               &range.level[1].cat)) {
				yyerror("out of memory");
				free(rt);
				return -1;
			}
			rt->next = policydbp->range_tr;
			policydbp->range_tr = rt;
		}
	}

	type_set_destroy(&doms);
	type_set_destroy(&types);
	ebitmap_destroy(&range.level[0].cat);
	ebitmap_destroy(&range.level[1].cat);
	return 0;
}

/* FLASK */


#line 4914 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 3:
#line 209 "policy_parse.y"
{ if (define_policy(pass, 0) == -1) return -1; }
break;
case 4:
#line 211 "policy_parse.y"
{ if (pass == 1) { if (policydb_index_classes(policydbp)) return -1; }
                            else if (pass == 2) { if (policydb_index_others(NULL, policydbp, 0)) return -1; }}
break;
case 5:
#line 214 "policy_parse.y"
{ if (pass == 1) { if (policydb_index_bools(policydbp)) return -1;}
			   else if (pass == 2) { if (policydb_index_others(NULL, policydbp, 0)) return -1;}}
break;
case 9:
#line 222 "policy_parse.y"
{if (define_class()) return -1;}
break;
case 12:
#line 228 "policy_parse.y"
{if (define_initial_sid()) return -1;}
break;
case 18:
#line 239 "policy_parse.y"
{if (define_common_perms()) return -1;}
break;
case 21:
#line 245 "policy_parse.y"
{if (define_av_perms(FALSE)) return -1;}
break;
case 22:
#line 247 "policy_parse.y"
{if (define_av_perms(TRUE)) return -1;}
break;
case 23:
#line 249 "policy_parse.y"
{if (define_av_perms(TRUE)) return -1;}
break;
case 29:
#line 260 "policy_parse.y"
{if (define_sens()) return -1;}
break;
case 30:
#line 262 "policy_parse.y"
{if (define_sens()) return -1;}
break;
case 32:
#line 267 "policy_parse.y"
{if (define_dominance()) return -1;}
break;
case 33:
#line 269 "policy_parse.y"
{if (define_dominance()) return -1;}
break;
case 38:
#line 278 "policy_parse.y"
{if (define_category()) return -1;}
break;
case 39:
#line 280 "policy_parse.y"
{if (define_category()) return -1;}
break;
case 42:
#line 286 "policy_parse.y"
{if (define_level()) return -1;}
break;
case 43:
#line 288 "policy_parse.y"
{if (define_level()) return -1;}
break;
case 48:
#line 297 "policy_parse.y"
{ if (define_constraint((constraint_expr_t*)yyvsp[-1].valptr)) return -1; }
break;
case 49:
#line 300 "policy_parse.y"
{ if (define_validatetrans((constraint_expr_t*)yyvsp[-1].valptr)) return -1; }
break;
case 69:
#line 326 "policy_parse.y"
{ if (define_attrib()) return -1;}
break;
case 70:
#line 329 "policy_parse.y"
{if (define_type(1)) return -1;}
break;
case 71:
#line 331 "policy_parse.y"
{if (define_type(0)) return -1;}
break;
case 72:
#line 334 "policy_parse.y"
{if (define_typealias()) return -1;}
break;
case 73:
#line 337 "policy_parse.y"
{if (define_typeattribute()) return -1;}
break;
case 76:
#line 343 "policy_parse.y"
{if (define_bool()) return -1;}
break;
case 77:
#line 346 "policy_parse.y"
{ if (insert_id("T",0)) return -1; }
break;
case 78:
#line 348 "policy_parse.y"
{ if (insert_id("F",0)) return -1; }
break;
case 79:
#line 351 "policy_parse.y"
{ if (pass == 2) { if (define_conditional((cond_expr_t*)yyvsp[-4].ptr, (avrule_t*)yyvsp[-2].ptr, (avrule_t*)yyvsp[0].ptr) < 0) return -1;  }}
break;
case 80:
#line 354 "policy_parse.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 81:
#line 356 "policy_parse.y"
{ yyval.ptr = NULL; }
break;
case 82:
#line 358 "policy_parse.y"
{ yyval.ptr = yyvsp[-1].ptr;}
break;
case 83:
#line 360 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_NOT, yyvsp[0].ptr, 0);
			  if (yyval.ptr == 0) return -1; }
break;
case 84:
#line 363 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_AND, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return  -1; }
break;
case 85:
#line 366 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_OR, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return   -1; }
break;
case 86:
#line 369 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_XOR, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return  -1; }
break;
case 87:
#line 372 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_EQ, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return  -1; }
break;
case 88:
#line 375 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_NEQ, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return  -1; }
break;
case 89:
#line 378 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 90:
#line 381 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_BOOL,0, 0);
			  if (yyval.ptr == COND_ERR) return   -1; }
break;
case 91:
#line 385 "policy_parse.y"
{ yyval.ptr = define_cond_pol_list((avrule_t *)yyvsp[-1].ptr, (avrule_t *)yyvsp[0].ptr); }
break;
case 92:
#line 387 "policy_parse.y"
{ yyval.ptr = NULL; }
break;
case 93:
#line 390 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 94:
#line 392 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 95:
#line 394 "policy_parse.y"
{ yyval.ptr = NULL; }
break;
case 96:
#line 397 "policy_parse.y"
{ yyval.ptr = define_cond_compute_type(AVRULE_TRANSITION) ;
                          if (yyval.ptr == COND_ERR) return -1;}
break;
case 97:
#line 400 "policy_parse.y"
{ yyval.ptr = define_cond_compute_type(AVRULE_MEMBER) ;
                          if (yyval.ptr ==  COND_ERR) return -1;}
break;
case 98:
#line 403 "policy_parse.y"
{ yyval.ptr = define_cond_compute_type(AVRULE_CHANGE) ;
                          if (yyval.ptr == COND_ERR) return -1;}
break;
case 99:
#line 407 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 100:
#line 409 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 101:
#line 411 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 102:
#line 413 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 103:
#line 416 "policy_parse.y"
{ yyval.ptr = define_cond_te_avtab(AVRULE_ALLOWED) ;
                          if (yyval.ptr == COND_ERR) return -1; }
break;
case 104:
#line 420 "policy_parse.y"
{ yyval.ptr = define_cond_te_avtab(AVRULE_AUDITALLOW) ;
                          if (yyval.ptr == COND_ERR) return -1; }
break;
case 105:
#line 424 "policy_parse.y"
{ yyval.ptr = define_cond_te_avtab(AVRULE_AUDITDENY) ;
                          if (yyval.ptr == COND_ERR) return -1; }
break;
case 106:
#line 428 "policy_parse.y"
{ yyval.ptr = define_cond_te_avtab(AVRULE_DONTAUDIT);
                          if (yyval.ptr == COND_ERR) return -1; }
break;
case 107:
#line 432 "policy_parse.y"
{if (define_compute_type(AVRULE_TRANSITION)) return -1;}
break;
case 108:
#line 434 "policy_parse.y"
{if (define_compute_type(AVRULE_MEMBER)) return -1;}
break;
case 109:
#line 436 "policy_parse.y"
{if (define_compute_type(AVRULE_CHANGE)) return -1;}
break;
case 110:
#line 439 "policy_parse.y"
{ if (define_range_trans()) return -1; }
break;
case 116:
#line 448 "policy_parse.y"
{if (define_te_avtab(AVRULE_ALLOWED)) return -1; }
break;
case 117:
#line 451 "policy_parse.y"
{if (define_te_avtab(AVRULE_AUDITALLOW)) return -1; }
break;
case 118:
#line 454 "policy_parse.y"
{if (define_te_avtab(AVRULE_AUDITDENY)) return -1; }
break;
case 119:
#line 457 "policy_parse.y"
{if (define_te_avtab(AVRULE_DONTAUDIT)) return -1; }
break;
case 120:
#line 460 "policy_parse.y"
{if (define_te_avtab(AVRULE_NEVERALLOW)) return -1; }
break;
case 121:
#line 463 "policy_parse.y"
{if (define_role_types()) return -1;}
break;
case 122:
#line 465 "policy_parse.y"
{if (define_role_types()) return -1;}
break;
case 124:
#line 470 "policy_parse.y"
{if (define_role_trans()) return -1; }
break;
case 125:
#line 473 "policy_parse.y"
{if (define_role_allow()) return -1; }
break;
case 126:
#line 476 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 127:
#line 478 "policy_parse.y"
{ yyval.ptr = merge_roles_dom((role_datum_t*)yyvsp[-1].ptr, (role_datum_t*)yyvsp[0].ptr); if (yyval.ptr == 0) return -1;}
break;
case 128:
#line 481 "policy_parse.y"
{yyval.ptr = define_role_dom(NULL); if (yyval.ptr == 0) return -1;}
break;
case 129:
#line 483 "policy_parse.y"
{yyval.ptr = define_role_dom((role_datum_t*)yyvsp[-1].ptr); if (yyval.ptr == 0) return -1;}
break;
case 136:
#line 495 "policy_parse.y"
{ if (define_constraint((constraint_expr_t*)yyvsp[-1].valptr)) return -1; }
break;
case 137:
#line 498 "policy_parse.y"
{ if (define_validatetrans((constraint_expr_t*)yyvsp[-1].valptr)) return -1; }
break;
case 138:
#line 501 "policy_parse.y"
{ yyval.valptr = yyvsp[-1].valptr; }
break;
case 139:
#line 503 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NOT, yyvsp[0].valptr, 0);
			  if (yyval.valptr == 0) return -1; }
break;
case 140:
#line 506 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_AND, yyvsp[-2].valptr, yyvsp[0].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 141:
#line 509 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_OR, yyvsp[-2].valptr, yyvsp[0].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 142:
#line 512 "policy_parse.y"
{ yyval.valptr = yyvsp[0].valptr; }
break;
case 143:
#line 515 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_USER, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 144:
#line 518 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 145:
#line 521 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_TYPE, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 146:
#line 523 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 147:
#line 524 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_USER, yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 148:
#line 526 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 149:
#line 527 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_TARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 150:
#line 529 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 151:
#line 530 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_XTARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 152:
#line 532 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 153:
#line 533 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 154:
#line 535 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 155:
#line 536 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 156:
#line 538 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 157:
#line 539 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_XTARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 158:
#line 541 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 159:
#line 542 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 160:
#line 544 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 161:
#line 545 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 162:
#line 547 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 163:
#line 548 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_XTARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 164:
#line 551 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_USER, CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 165:
#line 553 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 166:
#line 554 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 167:
#line 556 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 168:
#line 557 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 169:
#line 560 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, yyvsp[0].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 170:
#line 562 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 171:
#line 563 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 172:
#line 565 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 173:
#line 566 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 174:
#line 569 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_L1L2, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 175:
#line 572 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_L1H2, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 176:
#line 575 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_H1L2, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 177:
#line 578 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_H1H2, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 178:
#line 581 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_L1H1, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 179:
#line 584 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_L2H2, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 180:
#line 588 "policy_parse.y"
{ yyval.valptr = CEXPR_EQ; }
break;
case 181:
#line 590 "policy_parse.y"
{ yyval.valptr = CEXPR_NEQ; }
break;
case 182:
#line 593 "policy_parse.y"
{ yyval.valptr = yyvsp[0].valptr; }
break;
case 183:
#line 595 "policy_parse.y"
{ yyval.valptr = CEXPR_DOM; }
break;
case 184:
#line 597 "policy_parse.y"
{ yyval.valptr = CEXPR_DOMBY; }
break;
case 185:
#line 599 "policy_parse.y"
{ yyval.valptr = CEXPR_INCOMP; }
break;
case 190:
#line 608 "policy_parse.y"
{if (define_user()) return -1;}
break;
case 195:
#line 617 "policy_parse.y"
{if (define_initial_sid_context()) return -1;}
break;
case 200:
#line 626 "policy_parse.y"
{if (define_fs_context(yyvsp[-3].val,yyvsp[-2].val)) return -1;}
break;
case 206:
#line 637 "policy_parse.y"
{if (define_port_context(yyvsp[-1].val,yyvsp[-1].val)) return -1;}
break;
case 207:
#line 639 "policy_parse.y"
{if (define_port_context(yyvsp[-3].val,yyvsp[-1].val)) return -1;}
break;
case 212:
#line 648 "policy_parse.y"
{if (define_netif_context()) return -1;}
break;
case 217:
#line 657 "policy_parse.y"
{if (define_ipv4_node_context(yyvsp[-2].val,yyvsp[-1].val)) return -1;}
break;
case 218:
#line 659 "policy_parse.y"
{if (define_ipv6_node_context()) return -1;}
break;
case 223:
#line 668 "policy_parse.y"
{if (define_fs_use(SECURITY_FS_USE_XATTR)) return -1;}
break;
case 224:
#line 670 "policy_parse.y"
{if (define_fs_use(SECURITY_FS_USE_TASK)) return -1;}
break;
case 225:
#line 672 "policy_parse.y"
{if (define_fs_use(SECURITY_FS_USE_TRANS)) return -1;}
break;
case 230:
#line 681 "policy_parse.y"
{if (define_genfs_context(1)) return -1;}
break;
case 231:
#line 682 "policy_parse.y"
{insert_id("-", 0);}
break;
case 232:
#line 683 "policy_parse.y"
{if (define_genfs_context(1)) return -1;}
break;
case 233:
#line 685 "policy_parse.y"
{if (define_genfs_context(0)) return -1;}
break;
case 234:
#line 688 "policy_parse.y"
{ 
			  unsigned int addr;
	  		  unsigned char *p = ((unsigned char *)&addr);

			  p[0] = yyvsp[-6].val & 0xff;				
			  p[1] = yyvsp[-4].val & 0xff;
			  p[2] = yyvsp[-2].val & 0xff;
			  p[3] = yyvsp[0].val & 0xff;
			  yyval.val = addr;
			}
break;
case 238:
#line 705 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 239:
#line 707 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 240:
#line 710 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 241:
#line 712 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 246:
#line 722 "policy_parse.y"
{ if (insert_separator(0)) return -1; }
break;
case 247:
#line 724 "policy_parse.y"
{ if (insert_separator(0)) return -1; }
break;
case 248:
#line 726 "policy_parse.y"
{ if (insert_id("*", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
break;
case 249:
#line 729 "policy_parse.y"
{ if (insert_id("~", 0)) return -1;
			  if (insert_separator(0)) return -1; }
break;
case 250:
#line 732 "policy_parse.y"
{ if (insert_id("~", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
break;
case 251:
#line 734 "policy_parse.y"
{ if (insert_id("-", 0)) return -1; }
break;
case 252:
#line 735 "policy_parse.y"
{ if (insert_separator(0)) return -1; }
break;
case 253:
#line 738 "policy_parse.y"
{ if (insert_id("~", 1)) return -1; }
break;
case 254:
#line 741 "policy_parse.y"
{ if (insert_id("*", 1)) return -1; }
break;
case 262:
#line 753 "policy_parse.y"
{ if (insert_id(yytext, 1)) return -1; }
break;
case 269:
#line 762 "policy_parse.y"
{ if (insert_id("-", 0)) return -1; }
break;
case 272:
#line 765 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
case 273:
#line 768 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
case 274:
#line 771 "policy_parse.y"
{ if (insert_id(yytext, 1)) return -1; }
break;
case 284:
#line 785 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
case 285:
#line 788 "policy_parse.y"
{ yyval.val = strtoul(yytext,NULL,0); }
break;
case 286:
#line 791 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
case 287:
#line 797 "policy_parse.y"
{ if (end_avrule_block(pass) == -1) return -1;
                          if (policydb_index_others(NULL, policydbp, 0)) return -1;
                        }
break;
case 288:
#line 802 "policy_parse.y"
{ if (define_policy(pass, 1) == -1) return -1; }
break;
case 289:
#line 805 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
case 304:
#line 828 "policy_parse.y"
{ if (require_class(pass)) return -1; }
break;
case 305:
#line 830 "policy_parse.y"
{ yyval.require_func = require_role; }
break;
case 306:
#line 831 "policy_parse.y"
{ yyval.require_func = require_type; }
break;
case 307:
#line 832 "policy_parse.y"
{ yyval.require_func = require_attribute; }
break;
case 308:
#line 833 "policy_parse.y"
{ yyval.require_func = require_user; }
break;
case 309:
#line 834 "policy_parse.y"
{ yyval.require_func = require_bool; }
break;
case 310:
#line 841 "policy_parse.y"
{ if (yyvsp[-1].require_func (pass)) return -1; }
break;
case 311:
#line 843 "policy_parse.y"
{ if (yyvsp[-3].require_func (pass)) return -1; }
break;
case 312:
#line 846 "policy_parse.y"
{ if (end_avrule_block(pass) == -1) return -1; }
break;
case 313:
#line 848 "policy_parse.y"
{ if (end_optional(pass) == -1) return -1; }
break;
case 314:
#line 851 "policy_parse.y"
{ if (end_avrule_block(pass) == -1) return -1; }
break;
case 316:
#line 855 "policy_parse.y"
{ if (begin_optional(pass) == -1) return -1; }
break;
case 317:
#line 858 "policy_parse.y"
{ if (begin_optional_else(pass) == -1) return -1; }
break;
#line 5866 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
